# subroutine defining axial tilt and rotation of planets

for a=1:sy.planets
  if (sy.companion(a)==0)     #determine the gravity felt depending on which system planets are in
      gravfelt=primgrav;
    else
      gravfelt=compgrav;
    endif
if (sy.planet(a)==0)
    sy.axis.tilt(a)=0;
    sy.axis.rotation(a)=0;
  else  
    if ((sy.planetlocate(a)==1)+(sy.temp(a)==-1))  #inner planet or cycles daily planet
        b=roll(2);
        period= 365*sqrt((sy.orbit(a)/150)^3/gravfelt);
        if (b<5)
            sy.axis.rotation(a)=ceil(period*12);
          elseif (b<7)
            sy.axis.rotation(a)=ceil(period*16);
          elseif (b<9)
            sy.axis.rotation(a)=ceil(period*24);
          elseif (b<11)
            sy.axis.rotation(a)=ceil(period*9.6);
          elseif (b<12)
            sy.axis.rotation(a)=ceil(period*8);
          else
            sy.axis.rotation(a)=ceil(period*6);
          endif
      else
        if (sy.planet(a)<14)             #middle to outer rocky planet
            sy.axis.rotation(a)=8+roll(6);
          else                           #middle to outer giant planet
            sy.axis.rotation(a)=6+roll(2);
          endif
      endif
    if (sy.axis.rotation(a)>48)
        sy.axis.tilt(a)=0;
      else  
        b=roll(2);                           #find degree of axial tilt
        if (b<4)
            sy.axis.tilt(a)=roll(1)-1;
          elseif (b<6)
            sy.axis.tilt(a)= 5+roll(1);
          elseif (b<8)
            sy.axis.tilt(a)= 10+roll(2);
          elseif (b<10)
            sy.axis.tilt(a)= 15+roll(3);
          elseif (b<12)
            sy.axis.tilt(a)= 20+roll(5);
          else
            sy.axis.tilt(a)= 30+roll(8);
          endif
      endif
  endif  
  endfor

  
  


