# determine the hex distance between two systems

function dis=distance(sy,sys)
a=location(sy);
b=location(sys);

dis=0;
while (((a(1)==b(1))*(a(2)==b(2)))==0)
  x= b(1)-a(1);
  y= b(2)-a(2);
  if (x==0)   # correct X column
      dis=dis + abs(b(2)-a(2));     # jump to correct hex, adding the spaces
      b(2)=a(2);
    else      # not correct X columns
      dis=dis+1;
      c=rem(a(1),2);    # starting hex even=0, starting hex odd=1
      a(2)= a(2)- 1*((c==1)*(b(2)<a(2)));  # subtract 1 when starting in an odd hex and target is below
      a(2)= a(2)+ 1*((c==0)*(b(2)>a(2)));  # add 1 when starting in an even hex and target is above
      a(1)= a(1)+ 1*(b(1)>a(1)) - 1*(b(1)<a(1));   # move starting hex toward b by 1
    endif
  endwhile  
  
endfunction

