# location and distance calculations

for aa=1:length(tr)     #determine the cluster location of each system overall
  tr(aa).fullcount=aa;
  location_array(aa,:)= location(tr(aa));
  endfor

printf("Saving location array data.\n");
temp=[newdir "-locationarray.mat"];
save(temp, "location_array");
distance_array=ones(length(tr),length(tr))*99;
for aa=1:length(tr)     #determine the distance between any 2 systems in the cluster
  for bb=1:aa
    cc=min([15,abs(location_array(aa,1)-location_array(bb,1)),abs(location_array(aa,2)-location_array(bb,2))]);
    if cc<15   # if 2 systems might be close enough to be important to one another
        distance_array(aa,bb)=locationdistance(location_array(aa,:),location_array(bb,:));
        distance_array(bb,aa)=distance_array(aa,bb);
      endif
    endfor
  if (aa/50==ceil(aa/50))
      printf("%d distances calculated.\n", aa);
      fflush(stdout);
    endif
  endfor
printf("Saving distance array data.\n");
temp=[newdir "-distancearray.mat"];
save(temp, "distance_array");
