# testing how to improve confederation

# x= subsector x coordinate
# y= subsector y coordinate
# sys= array of system variables
# M3= variable used for defining the setting size and density
full_variables

more off
#create the linear array for analysis
    clear trav
    cnt=1;
    for a=max(1,(x-1)):min(length(M3(:,1)),(x+1))       #loop through the array matrix on all sides of the subsector
      for b=max(1,(y-1)):min(length(M3(1,:)),(y+1))     #  without going beyond the setting!
        if ((a==x)*(b==y))
            srt=cnt;
          endif  
        for c=1:length(sys(a,b,:))               #convert abc to linear array and save order
          if (sys(a,b,c).starnum>0)
              revert(cnt,:)=[a b c];
              trav(cnt)=sys(a,b,c);
              cnt=cnt+1;
            endif 
          endfor
        if ((a==x)*(b==y))
            en=cnt-1;
          endif  
        endfor  
      endfor

# make the influence matrix only once
plant=newinfluence(trav);
staremp=plant;
if (syst_starempire==1)
    for a=1:length(trav)      # zero out influence of non-jump systems
      staremp(:,a)= staremp(:,a)*(trav(a).starport=='A');
      endfor      
  endif  
    
for a=srt:en                  # only calculate influences for the middle subsector of interest
  clear temp
  temp.confed= confedonly(a,trav);
  temp.self= influence(trav(a));
  temp.independent=0;
  temp.dominate(1)=0;
  temp.ally(1,:)=[0 0 0];
  if (syst_starempire==1)
      test=staremp;
    else
      test=plant;
    endif
  [i j]=max(test(a,:));  # find most influential system on the current
  if (temp.self>=i)
      temp.independent=1*(i>0);          # if self, the planet leads itself and not part of someone else's pocket empire
      test(a,a)=0;
    endif
  for b=1:5
    [i j]=max(test(a,:));   # find 5 most influential systems
    temp.score(b)=i;
    temp.ndx(b,1)=revert(j,1);
    temp.ndx(b,2)=revert(j,2);
    temp.ndx(b,3)=revert(j,3);
    test(a,j)=0;         # remove influential system from list after being chosen
    endfor
  k=1;
  if ((syst_starempire==0)+(trav(a).starport=='A'))
      for b=1:length(staremp)
        [i j]=max(staremp(b,:));
        if ((a==j)*(a!=b)*(staremp(b,b)<i))       #is current planet dominant over planet b,not itself, and not equal to planet b's influence?
            temp.ally(k,1)=revert(b,1);
            temp.ally(k,2)=revert(b,2);
            temp.ally(k,3)=revert(b,3);
            temp.dominate(k)=i;
            k=k+1;
          endif
        endfor
    endif
  sys(revert(a,1), revert(a,2), revert(a,3)).influ=temp;  # assign influ structure to original sys variables
 
  # display output of influences on the chosen world
#{
  printf("%s has an individual influence rating of %d in the M317 cluster.\n", trav(a).name, temp.self);
  printf("The Confederation government has %d influence here.\n", temp.confed);
  if ((trav(a).govern==6)*(temp.confed>temp.score(1)))
      printf("The Confederation is in control of %s's captive government.\n", trav(a).name);
  endif  
  if (temp.independent==1)
    printf("  %s is independent of control from any nearby system.\n", trav(a).name);
  endif
  printf("\nThe 5 most influential local systems in %s are:\n", trav(a).name);
  for b=1:5
    printf("   %s with an influence of %d.", sys(temp.ndx(b,1),temp.ndx(b,2),temp.ndx(b,3)).name, temp.score(b));
    if ((b==1)*(temp.score(b)>temp.self))
        if ((trav(a).govern==6)*(temp.confed<(temp.score(1)+1)))
            printf("  %s is in control of %s's captive government.\n", sys(temp.ndx(b,1),temp.ndx(b,2),temp.ndx(b,3)).name, trav(a).name);
          else
            printf("  %s is part of %s's pocket empire.\n", trav(a).name, sys(temp.ndx(b,1),temp.ndx(b,2),temp.ndx(b,3)).name);
          endif  
      else
        printf("\n");
      endif  
    endfor
if (temp.ally(1,1)>0)
    printf("\nSystems in %s's pocket empire are:\n", trav(a).name);
    for b=1:length(temp.dominate)
      printf("   %s has an influence of %d compared to their %d.\n", sys(temp.ally(b,1),temp.ally(b,2), temp.ally(b,3)).name, temp.self, temp.dominate(b));
      endfor
  endif
printf("\n");
#}
 
  endfor

more on  