# command file generating setting personality ratings

# first pass- X starports, 0 population worlds, nonexistent worlds, independent worlds
noratings= 16*ones(1,15);
V=zeros(length(sys(:,1,1)), length(sys(1,:,1)), length(sys(1,1,:)));

function cha15=randperson()
  cha15=zeros(1,15);
  for a=1:15                # random base 0-15 for each characteristic
    cha15(a)=roll(3)-3;
  endfor
  endfunction
  

for aa=1:length(sys(:,1,1))
  for bb=1:length(sys(1,:,1))
    for cc=1:length(sys(1,1,:))
      if (sys(aa,bb,cc).starnum>0)
          if (sys(aa,bb,cc).population==0)
              sys(aa,bb,cc).personality=noratings;
              V(aa,bb,cc)=1;
            elseif (sys(aa,bb,cc).starport=='X')
              sys(aa,bb,cc).personality=randperson()+personality(sys(aa,bb,cc));
              V(aa,bb,cc)=1;
            elseif (sys(aa,bb,cc).influ.independent==1)
              sys(aa,bb,cc).personality=randperson()+personality(sys(aa,bb,cc));
              V(aa,bb,cc)=1;
            elseif ((sys(aa,bb,cc).influ.independent==0)*(V(aa,bb,cc)==0))   #mutually dependent worlds
              a1=sys(aa,bb,cc).influ.ndx(1,1);
              b1=sys(aa,bb,cc).influ.ndx(1,2);
              c1=sys(aa,bb,cc).influ.ndx(1,3);
              a=sys(a1,b1,c1).influ.ndx(1,1); 
              b=sys(a1,b1,c1).influ.ndx(1,2); 
              c=sys(a1,b1,c1).influ.ndx(1,3);
              if ((a==aa)*(b==bb)*(c==cc))
                  t1= randperson()+ personality(sys(aa,bb,cc));
                  t2= randperson()+ personality(sys(a1,b1,c1));
                  sys(aa,bb,cc).personality= ceil((t1+t2)/2);
                  sys(a1,b1,c1).personality= ceil((t1+t2)/2);
                  V(aa,bb,cc)=1;
                  V(a1,b1,c1)=1;
                endif
            endif    
        else
          sys(aa,bb,cc).personality= noratings;
          V(aa,bb,cc)=1;
        endif  
      endfor
    endfor
  endfor

# repeat 4 times until all values assigned, then one last time ignoring recursive calculations

for tester=1:5
  for aa=1:length(sys(:,1,1))
    for bb=1:length(sys(1,:,1))
      for cc=1:length(sys(1,1,:))
        t1= zeros(1,15);
        t2= zeros(1,15);
        t3= zeros(1,15);
        t4= zeros(1,15);
        t5= zeros(1,15);
        if (V(aa,bb,cc)==0)
            if (sys(aa,bb,cc).starport=='E')
                a1=sys(aa,bb,cc).influ.ndx(1,1);
                b1=sys(aa,bb,cc).influ.ndx(1,2);
                c1=sys(aa,bb,cc).influ.ndx(1,3);
                if (V(a1,b1,c1)==1)
                    t1= randperson()+ personality(sys(aa,bb,cc));
                    sys(aa,bb,cc).personality=round((2*t1+ sys(a1,b1,c1).personality)/3);
                    V(aa,bb,cc)=1;
                  elseif (tester==5)
                    sys(aa,bb,cc).personality=randperson()+ personality(sys(aa,bb,cc));
                    V(aa,bb,cc)=1;
                  endif
              
              elseif (sys(aa,bb,cc).starport=='D')    
                a1=sys(aa,bb,cc).influ.ndx(1,1);
                b1=sys(aa,bb,cc).influ.ndx(1,2);
                c1=sys(aa,bb,cc).influ.ndx(1,3);
                if (V(a1,b1,c1)==1)
                    t1= randperson()+ personality(sys(aa,bb,cc));
                    sys(aa,bb,cc).personality=round((t1+2*sys(a1,b1,c1).personality)/3);
                    V(aa,bb,cc)=1;
                  elseif (tester==5)
                    sys(aa,bb,cc).personality=randperson()+ personality(sys(aa,bb,cc));
                    V(aa,bb,cc)=1;
                  endif
              
              elseif (sys(aa,bb,cc).starport=='C')
                a1=sys(aa,bb,cc).influ.ndx(1,1);
                b1=sys(aa,bb,cc).influ.ndx(1,2);
                c1=sys(aa,bb,cc).influ.ndx(1,3);
                v1=0;
                v2=0;
                v3=0;
                v4=0;
                n1=1;
                n2=0;
                n3=0;
                n4=0;
                if (sys(aa,bb,cc).influ.ndx(2,1)>0)
                    a2=sys(aa,bb,cc).influ.ndx(2,1);
                    b2=sys(aa,bb,cc).influ.ndx(2,2);
                    c2=sys(aa,bb,cc).influ.ndx(2,3);
                    if ((a2==aa)*(b2==bb)*(c2==cc))
                        n2=0;
                      else  
                        n2=1;
                      endif  
                  endif  
                if (sys(aa,bb,cc).influ.ndx(3,1)>0)
                    a3=sys(aa,bb,cc).influ.ndx(3,1);
                    b3=sys(aa,bb,cc).influ.ndx(3,2);
                    c3=sys(aa,bb,cc).influ.ndx(3,3);
                    if ((a3==aa)*(b3==bb)*(c3==cc))
                        n3=0;
                      else  
                        n3=1;
                      endif  
                  endif
                if (sys(aa,bb,cc).influ.ndx(4,1)>0)
                    a4=sys(aa,bb,cc).influ.ndx(4,1);
                    b4=sys(aa,bb,cc).influ.ndx(4,2);
                    c4=sys(aa,bb,cc).influ.ndx(4,3);
                    if ((a4==aa)*(b4==bb)*(c4==cc))
                        n4=0;
                      else  
                        n4=1;
                      endif  
                  endif  
                if (V(a1,b1,c1)==1)
                    t1=sys(a1,b1,c1).personality;
                    v1=1;
                  endif  
                if ((V(a2,b2,c2)==1)*(n2==1))
                    t2=sys(a2,b2,c2).personality;
                    v2=1;
                  endif  
                if ((V(a3,b3,c3)==1)*(n3==1))
                    t3=sys(a3,b3,c3).personality;
                    v3=1;
                  endif  
                if ((V(a4,b4,c4)==1)*(n4==1))
                    t4=sys(a4,b4,c4).personality;
                    v4=1;
                  endif
                modif= v2*((t1-t2)*.2) + v3*((t1-t3)*.1) + v4*((t1-t4)*.05);  
                if ((v1==n1)*(v2==n2)*(v3==n3)*(v4==n4)*(tester<5))
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  elseif (tester==5)
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  endif             

              elseif (sys(aa,bb,cc).starport=='B')
                a1=sys(aa,bb,cc).influ.ndx(1,1);
                b1=sys(aa,bb,cc).influ.ndx(1,2);
                c1=sys(aa,bb,cc).influ.ndx(1,3);
                v1=0;
                v2=0;
                v3=0;
                v4=0;
                v5=0;
                n1=1;
                n2=0;
                n3=0;
                n4=0;
                n5=0;
                if (sys(aa,bb,cc).influ.ndx(2,1)>0)
                    a2=sys(aa,bb,cc).influ.ndx(2,1);
                    b2=sys(aa,bb,cc).influ.ndx(2,2);
                    c2=sys(aa,bb,cc).influ.ndx(2,3);
                    if ((a2==aa)*(b2==bb)*(c2==cc))
                        n2=0;
                      else  
                        n2=1;
                      endif  
                  endif  
                if (sys(aa,bb,cc).influ.ndx(3,1)>0)
                    a3=sys(aa,bb,cc).influ.ndx(3,1);
                    b3=sys(aa,bb,cc).influ.ndx(3,2);
                    c3=sys(aa,bb,cc).influ.ndx(3,3);
                    if ((a3==aa)*(b3==bb)*(c3==cc))
                        n3=0;
                      else  
                        n3=1;
                      endif  
                  endif
                if (sys(aa,bb,cc).influ.ndx(4,1)>0)
                    a4=sys(aa,bb,cc).influ.ndx(4,1);
                    b4=sys(aa,bb,cc).influ.ndx(4,2);
                    c4=sys(aa,bb,cc).influ.ndx(4,3);
                    if ((a4==aa)*(b4==bb)*(c4==cc))
                        n4=0;
                      else  
                        n4=1;
                      endif  
                  endif  
                if (sys(aa,bb,cc).influ.ndx(5,1)>0)
                    a5=sys(aa,bb,cc).influ.ndx(5,1);
                    b5=sys(aa,bb,cc).influ.ndx(5,2);
                    c5=sys(aa,bb,cc).influ.ndx(5,3);
                    if ((a5==aa)*(b5==bb)*(c5==cc))
                        n5=0;
                      else  
                        n5=1;
                      endif  
                  endif  
                if (V(a1,b1,c1)==1)
                    t1=sys(a1,b1,c1).personality;
                    v1=1;
                  endif  
                if ((V(a2,b2,c2)==1)*(n2==1))
                    t2=sys(a2,b2,c2).personality;
                    v2=1;
                  endif  
                if ((V(a3,b3,c3)==1)*(n3==1))
                    t3=sys(a3,b3,c3).personality;
                    v3=1;
                  endif  
                if ((V(a4,b4,c4)==1)*(n4==1))
                    t4=sys(a4,b4,c4).personality;
                    v4=1;
                  endif  
                if ((V(a5,b5,c5)==1)*(n5==1))
                    t5=sys(a5,b5,c5).personality;
                    v5=1;
                  endif  
                modif= v2*((t1-t2)*.3) + v3*((t1-t3)*.2) + v4*((t1-t4)*.1)+ v5*(t1-t5)*.05;
                if ((v1==n1)*(v2==n2)*(v3==n3)*(v4==n4)*(v5==n5)*(tester<5))
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  elseif (tester==5)
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  endif             
              
              elseif (sys(aa,bb,cc).starport=='A')
                a1=sys(aa,bb,cc).influ.ndx(1,1);
                b1=sys(aa,bb,cc).influ.ndx(1,2);
                c1=sys(aa,bb,cc).influ.ndx(1,3);
                v1=0;
                v2=0;
                v3=0;
                v4=0;
                v5=0;
                n1=1;
                n2=0;
                n3=0;
                n4=0;
                n5=0;
                if (sys(aa,bb,cc).influ.ndx(2,1)>0)
                    a2=sys(aa,bb,cc).influ.ndx(2,1);
                    b2=sys(aa,bb,cc).influ.ndx(2,2);
                    c2=sys(aa,bb,cc).influ.ndx(2,3);
                    if ((a2==aa)*(b2==bb)*(c2==cc))
                        n2=0;
                      else  
                        n2=1;
                      endif  
                  endif  
                if (sys(aa,bb,cc).influ.ndx(3,1)>0)
                    a3=sys(aa,bb,cc).influ.ndx(3,1);
                    b3=sys(aa,bb,cc).influ.ndx(3,2);
                    c3=sys(aa,bb,cc).influ.ndx(3,3);
                    if ((a3==aa)*(b3==bb)*(c3==cc))
                        n3=0;
                      else  
                        n3=1;
                      endif  
                  endif
                if (sys(aa,bb,cc).influ.ndx(4,1)>0)
                    a4=sys(aa,bb,cc).influ.ndx(4,1);
                    b4=sys(aa,bb,cc).influ.ndx(4,2);
                    c4=sys(aa,bb,cc).influ.ndx(4,3);
                    if ((a4==aa)*(b4==bb)*(c4==cc))
                        n4=0;
                      else  
                        n4=1;
                      endif  
                  endif  
                if (sys(aa,bb,cc).influ.ndx(5,1)>0)
                    a5=sys(aa,bb,cc).influ.ndx(5,1);
                    b5=sys(aa,bb,cc).influ.ndx(5,2);
                    c5=sys(aa,bb,cc).influ.ndx(5,3);
                    if ((a5==aa)*(b5==bb)*(c5==cc))
                        n5=0;
                      else  
                        n5=1;
                      endif  
                  endif  
                if (V(a1,b1,c1)==1)
                    t1=sys(a1,b1,c1).personality;
                    v1=1;
                  endif  
                if ((V(a2,b2,c2)==1)*(n2==1))
                    t2=sys(a2,b2,c2).personality;
                    v2=1;
                  endif  
                if ((V(a3,b3,c3)==1)*(n3==1))
                    t3=sys(a3,b3,c3).personality;
                    v3=1;
                  endif  
                if ((V(a4,b4,c4)==1)*(n4==1))
                    t4=sys(a4,b4,c4).personality;
                    v4=1;
                  endif  
                if ((V(a5,b5,c5)==1)*(n5==1))
                    t5=sys(a5,b5,c5).personality;
                    v5=1;
                  endif  
                modif= v2*((t1-t2)*.4) + v3*((t1-t3)*.3) + v4*((t1-t4)*.2)+ v5*(t1-t5)*.1;
                if ((v1==n1)*(v2==n2)*(v3==n3)*(v4==n4)*(v5==n5)*(tester<5))
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  elseif (tester==5)
                    sys(aa,bb,cc).personality=round(t1-modif);
                    V(aa,bb,cc)=1;
                  endif             
              endif
          endif
        if ((sys(aa,bb,cc).population>0)*V(aa,bb,cc)==1)
            temp=sys(aa,bb,cc).personality(10);
            temp2=sys.law;
            temp=min(temp, (3+(2*temp2)));
            temp=max(temp, ((2*temp2) -5));
            sys(aa,bb,cc).personality(10)=temp;
            round(sys(aa,bb,cc).personality);
            for a=1:15   # set minimum and maximum values
              sys(aa,bb,cc).personality(a)= min(sys(aa,bb,cc).personality(a),15);
              sys(aa,bb,cc).personality(a)= max(sys(aa,bb,cc).personality(a),0);
              endfor
          endif
        endfor
      endfor
    endfor
  printf("personality pass %d, all assigned (1=true): %d.\n", tester, min(min(min(V))));
  fflush(stdout);  
  endfor

  for aa=1:length(sys(:,1,1))
    for bb=1:length(sys(1,:,1))
      for cc=1:length(sys(1,1,:))
        # assign minimum/maximum values based on other system characteristics
        if (sys(aa,bb,cc).govern==13) # religious dictatorships are for piety
            sys(aa,bb,cc).personality(12)=max(sys(aa,bb,cc).personality(12),10);
          endif
        for a=1:length(sys(aa,bb,cc).populate)
          if (sys(aa,bb,cc).populate(a).pn==4) # reptilians don't like psionics
              sys(aa,bb,cc).personality(13)=min(sys(aa,bb,cc).personality(13),9);
            endif
          if (sys(aa,bb,cc).populate(a).pn==3) # insectans don't like isolation/materialism
              sys(aa,bb,cc).personality(6)=min(6,sys(aa,bb,cc).personality(6));
              sys(aa,bb,cc).personality(7)=max(9,sys(aa,bb,cc).personality(7));
            endif
          if ((sys(aa,bb,cc).populate(a).pn>10)*(sys(aa,bb,cc).populate(1).pn<999))  # non-standard aliens
              race=sys(aa,bb,cc).populate(a).pn-10;
              for b= 1:newrace(race).race.traits
                if (newrace(race).race.trait(b)==42)  # gearheads like robots & at least tolerate chrome
                    sys(aa,bb,cc).personality(1)=min(9, sys(aa,bb,cc).personality(1));
                    sys(aa,bb,cc).personality(15)=min(10,sys(aa,bb,cc).personality(15));
                  endif
                if (newrace(race).race.trait(b)==35) # xenoempathy reduces isolation
                    sys(aa,bb,cc).personality(6)=min(9,sys(aa,bb,cc).personality(6));
                  endif
                if ((newrace(race).race.trait(b)==53)+(newrace(race).race.trait(b)==60))
                    # trustworthy and naturally honest races value honesty
                    sys(aa,bb,cc).personality(5)=max(sys(aa,bb,cc).personality(5),9);
                  endif
                tvals=[6,30,46,58,93]; # races with weapons and attacks won't support pacifism
                for c=1:length(tvals)
                  if (newrace(race).race.trait(b)==tvals(c))
                      sys(aa,bb,cc).personality(11)=max(9, sys(aa,bb,cc).personality(11));
                    endif
                  endfor
                if (newrace(race).race.trait(b)==23)  #psionic races accept psionics
                    sys(aa,bb,cc).personality(13)=min(9, sys(aa,bb,cc).personality(13));
                  endif
                if ((newrace(race).race.trait(b)==25)+(newrace(race).race.trait(b)==28))
                    # psionically dead races don't like psionics
                    sys(aa,bb,cc).personality(13)=max(9, sys(aa,bb,cc).personality(13));
                  endif
                if (newrace(race).race.trait(b)==59)  #well traveled races are not isolationist
                    sys(aa,bb,cc).personality(6)=max(6, sys(aa,bb,cc).personality(6));
                  endif
                tvals=[54,55,56,92]; # violent races won't support pacifism
                for c=1:length(tvals)
                  if (newrace(race).race.trait(b)==tvals(c))
                      sys(aa,bb,cc).personality(11)=max(5, sys(aa,bb,cc).personality(11));
                    endif
                  endfor
                if (newrace(race).race.trait(b)==70)  #feral races are not tech oriented
                    sys(aa,bb,cc).personality(1)=max(9,sys(aa,bb,cc).personality(1));
                    sys(aa,bb,cc).personality(15)=max(9,sys(aa,bb,cc).personality(15));
                    sys(aa,bb,cc).personality(4)=max(9,sys(aa,bb,cc).personality(4));
                    sys(aa,bb,cc).tech=max(9,sys(aa,bb,cc).tech);
                  endif
                endfor
            endif
          endfor
        endfor
      endfor
    endfor