# calculate confederation influence only

function confed=testconfedonly(a,trav,da)    # a is system in question, trav is full linear array of systems
                                        # da is distance_array
confed=0;
for b=1:length(trav)
  d=da(a,b);
  if (d<8)   #only if it is possibly close enough, count up the confederation influence          
      tmp=7*trav(b).naval + 5*trav(b).consul +3*trav(b).scout;
      affect=max(0,tmp-2*d);               # modify confed influence by distance from bases
      confed=confed+ affect;
    endif
  endfor
  
endfunction