# use slow distance array caluclation to speed up influence array processing
clear planetinfluence
clear planetinflu
    for aa=1:length(tr)
      baseinfluence(aa)=influence(tr(aa));   # build the base influence array
      tr(aa).influ.self=baseinfluence(aa);
      tr(aa).influ.independent=0;
      tr(aa).influ.dominate=[0];
      tr(aa).influ.ally(1,:)=[0 0 0];
      tr(aa).influ.ally=tr(aa).influ.ally(1:1,:);
      endfor
    full_influence_array  #create a full setting influence array
    staremp=planetinflu;
    if (syst_starempire==1)
        for a=1:length(tr)      # zero out influence of non-jump systems
        staremp(:,a)= staremp(:,a)*(tr(a).starport=='A');
          endfor 
      endif
    for aa=1:length(tr)
      test=staremp;
      [i j]=max(test(aa,:));  # find most influential system on the current
      if (tr(aa).influ.self>=i)
          tr(aa).influ.independent=1*(i>0);          # if self, the planet leads itself and not part of someone else's pocket empire
          test(aa,aa)=0;
        else
          bb=length(tr(j).influ.dominate)-(tr(j).influ.ally(1)==0);  # how many planets does the dominant one dominate?
          tr(j).influ.dominate(bb+1)=i;        # if other, add to their pocket empire list
          tr(j).influ.ally(bb+1,:)= [tr(aa).sector tr(aa).count];
        endif
      for b=1:5
        [i j]=max(test(aa,:));   # find 5 most influential systems
        tr(aa).influ.score(b)=i;
        tr(aa).influ.ndx(b,1)=tr(j).sector(1);
        tr(aa).influ.ndx(b,2)=tr(j).sector(2);
        tr(aa).influ.ndx(b,3)=tr(j).count;
        test(aa,j)=0;         # remove influential system from list after being chosen
        endfor
      endfor
 