# function file for writing up a system description
a=0;

#cycle through all the stars in the cluster, by sector
function printsector(sys, trav, newrace, olddir, newdir,tr,distance_array)
full_variables

sa=0;                #count of type A starports
sb=0;                #count of type B starports
sc=0;                #count of type C starports
sd=0;                #count of type D starports
se=0;                #count of type E starports
sx=0;                #count of type X starports
snav=0;              #count of naval bases
ssco=0;              #count of scout bases
said=0;              #count of explorer's aid society hostels
scon=0;              #count of consulates
st=zeros(16,1);      #counts of trade arrays
stech=0;             #for calculating average tech levels
slaw=0;              #for calculating average law level 
shab=0;              #for calculating average number of habitable worlds per system
  shabe=0;                 # easily habitable worlds
  shabs=0;                 # semi-habitable worlds
  shabb=0;                 # barely habitable worlds
  sgeo=0;                  # geothermally habitable worlds
  whab=zeros(15,1);        # count the number of systems with x habitable worlds
spop=0;               #number of uninhabited systems
snat=0;               #number of homeworlds in subsector
sgdp=0;               #GDP sum for averaging across worlds
smoo=0;               #best moons count
vas=0;                #frontier system counts
obs=0;                #observer system count
mem=0;                #member system count
adv=0;                #advisory system counts
amb=0;                #amber system counts
red=0;                #red system counts
sgovs=zeros(15,1);    #count of government types
stl=zeros(16,1);      #count of tech levels
slaws=zeros(10,1);    #count of each law level
demop=zeros(300,1);   #demographics of all races
demow=zeros(300,1);   #count of worlds with each race
spo=0;                #total population
spops=zeros(11,1);    #count of worlds with different population sizes
svegs=0;              #count of vestigial worlds
savi=0;               #count of avian favored worlds
sins=0;               #count of insectan favored worlds
smer=0;               #count of merfolk favored worlds
srep=0;               #count of reptilian favored worlds
stemps=zeros(10,1);   #count of temperatures of habitable worlds
sstars=0;             #total number of stars in star systems
sred=0;               #number of red stars
sora=0;               #number of orange stars
syel=0;               #number of yellow stars
swhi=0;               #number of white stars
sbro=0;               #number of brown dwarfs
sdwf=0;               #number of white dwarfs
sgia=0;               #number of giant stars
svar=0;               #number of variable stars
sfor=0;               #number of forming stars
mpoc=zeros(30,1);     #number of all pocket empires of 1-5, 6-10,... 46-50 in cluster
clear spoc;           #structure for independent pocket empires
spoc(1).name="";      #name of the pocket empire
spoc(1).loc=[0 0 0];  #location of the pocket empire in cluster
spoc(1).number=0;     #number of worlds in the pocket empires
spoc(1).combined=0;   #number of worlds in the combined pocket empires
poccnt=1;             #count of independent pocket empires
clear dpoc;           #structure for dependent pocket empires
dpoc(1).name="";
dpoc(1).loc=[0 0 0];
dpoc(1).number=0;
dcnt=1;               #count of dependent pocket empires
cpoc=zeros(30,1);     #number of combined empires if bins of 5, like mpoc
ssizes=zeros(11,1);   #count of sizes of habitable planets
mconf=zeros(5,1);     #degree of indpendence from Confederation strength
gdpcnt=zeros(10,1);   #array for counting how many of a gdp bin there are
personal=zeros(15,2); #array for counting high and low system personalities
stype=[0 0 0 0];      #array counting singletons, close binaries, distant binaries, and trinary systems  
cbases(1)=0;          #array for storing # of confederation bases to contact weekly
psystems(1)=0;        #array for storing # of pop 6+ systems nearby
jumpsys(1)=0;         #array for storing # of systems which can reach it in 1 jump
sys_ten(1)=0;         #array for storing # of systems nearby with influ 10+

cnt=length(trav)+1;

 # variables used for printing out key concepts 
restrict=['Green'; 'Amber'; 'Red'];
restring=['80FF80'; 'C0C040'; 'FF7070'];
tradecodes=['Ag'; 'Ds'; 'Fl'; 'Ga'; 'Hi'; 'Ht'; 'Ic'; 'In'; 'Lo'; 'Lt'; 'Na'; 'Ni'; 'Po'; 'Ri'; 'Wa'; 'Va'];
habstring=['not'; 'barely'; 'semi'; 'easily'];
habcolor=['FFFFFF'; 'FFFF00'; 'ccFFcc'; '00FF00'];
govstring=['no effective government'; 'a corporation'; 'a participatory democracy'; 'an oligarchy'; 'a republic'; 'a feudal technocracy'; 'a captive government'; 'several balkanized states'; 'a civil service bureaucracy'; 'an impersonal bureaucracy'; 'a charismatic leader'; 'a non-charismatic dictator'; 'a charismatic oligarchy'; 'a religious dictatorship'];
facstring=['minimal'; 'weak'; 'notable'; 'significant'; 'powerful'];
tradestring=['agricultural'; 'desert'; 'fluid ocean'; 'garden'; 'high population'; 'high tech'; 'ice capped'; 'industrial'; 'low population'; 'low tech'; 'non-agricultural'; 'non-industrial'; 'poor'; 'rich'; 'water'; 'vacuum'];
tempstring=['cycling daily'; 'frozen'; 'very cold'; 'cold'; 'cool'; 'temperate'; 'warm'; 'hot'; 'roasting'; 'boiling'];
atmostring=['no'; 'a trace'; 'a very thin tainted'; 'a very thin'; 'a thin, tainted'; 'a thin'; 'a standard'; 'a standard but tainted'; 'a dense normal'; 'a dense tainted'; 'an exotic'; 'a corrosive'; 'an insidious'; 'a very dense, unbreatheable'];
confedstring=['a frontier'; 'an observer'; 'a member'; 'an advisory'];
present=['-'; 'Y'];
rescode=['-'; 'A'; 'R'];
confed=['None'; 'Front'; ' Obs '; 'Memb '; 'Advis'];
favored=['Avians'; 'Insectans'; 'Merfolk'; 'Reptilians'];
nm=['human';'avian';'insectan';'merfolk';'reptilian';'uplifted ape';'uplifted feline';'uplifted mongoose';'uplifted dolphin'];
mconfstring=['puny'; 'weak'; 'equal'; 'solid'; 'overwhelming'];
centerstring=['outposts with tens'; 'hamlets with hundreds'; 'villages with thousands'; 'towns with tens of thousands'; 'small cities with hundreds of thousands'; 'large cities with millions'; 'metropolis with tens of millions'; 'arcologies with hundreds of millions'];
perstring=['minutes'; 'hours'; 'days'; 'weeks'; 'months'];
pdesc=['fanatically against'; 'solidly against'; 'clearly against'; 'mostly neutral toward'; 'mostly neutral toward';'clearly for'; 'solidly for'; 'fanatically for'];
ptypes=['cybernetics'; 'enthusiasm'; 'generosity'; 'gengineering'; 'honesty'; 'isolationism'; 'materialism'; 'openmindedness'; 'optimism'; 'order'; 'pacifism'; 'piety'; 'psionics'; 'racism'; 'robots'];
stypesize=['single'; 'close binaries'; 'distant binaries'; 'trinaries'];

# assign names and capabilities to racial abilities
trt(1,:)= 'acid resistance';
trt=cellstr(trt);
desc(1,:)= 'reduces damage caused by acid 50%';
desc=cellstr(desc);

trt(2,:)= 'acid vulnerability';
desc(2,:)= 'allows acid to do 50% extra damage';
trt(3,:)= 'altitude adaptation';
desc(3,:)= 'automatically adapted to high altitude/lower oxygen conditions';
trt(4,:)= 'regeneration';
desc(4,:)= 'allows healing in hours instead of days and allows limbs to regrow';
trt(5,:)= 'bad first impression';
desc(5,:)= 'causes immediate, temporary unfriendly attitude due to appearance/odor';
trt(6,:)= 'blind-fighter';
desc(6,:)= 'allows half normal combat penalties due to lack of vision';
trt(7,:)= 'cold endurance';
desc(7,:)= 'comfortable in the cold, receives -1d6 cold damage';
trt(8,:)= 'cold resistance; fire vulnerability';
desc(8,:)= 'cold adapted.  Half damage from cold, but 50% more from fire';
trt(9,:)= 'electricity resistance';
desc(9,:)= 'reduces damage caused by electricity by 50%';
trt(10,:)= 'observant';
desc(10,:)= 'allows a +2 DM bonus on recon checks';
trt(11,:)= 'fast healing';
desc(11,:)= 'causes +1d6 additional healing per day';
trt(12,:)= 'fire resistance; cold vulnerability';
desc(12,:)= 'heat adapted.  Half damage from fire, but 50% more from cold';
trt(13,:)= 'frightful presence';
desc(13,:)= 'make a leadership skill check or be intimidated with a -1 DM';
trt(14,:)= 'good first impression';
desc(14,:)= 'causes immediate, temporary friendly attitude due to appearance/odor';
trt(15,:)= 'heat endurance';
desc(15,:)= 'comfortable in hot environments, receives -1d6 fire damage';
trt(16,:)= 'hibernation';
desc(16,:)= 'ability to voluntarily enter a deep sleep for up to End days';
trt(17,:)= 'improved grab';
desc(17,:)= 'gives a +2 melee skill in grappling attacks';
trt(18,:)= 'improved grab: constrict';
desc(18,:)= 'gives a +1 melee skill in grappling with 1d6 squeezing damage';
trt(19,:)= 'improved grab: entangle';
desc(19,:)= 'gives a +1 melee skill in grappling with continued holding';
trt(20,:)= 'improved reach';
desc(20,:)= 'gives a +1.5m reach beyond normal for their size';
trt(21,:)= 'no fine manipulators';
desc(21,:)= 'lacks ability to manipulate small items';
trt(22,:)= 'pleasant odor';
desc(22,:)= 'gives +2 DM to detect by scent, make Int check or be unwilling to harm them';
trt(23,:)= 'psionic';
desc(23,:)= 'nearly all members of the species are psionic';
trt(24,:)= 'radiation resistance';
desc(24,:)= 'reduces all radiation exposures by 100 rads';
trt(25,:)= 'anti-psionic';
desc(25,:)= 'gives immunity to psionic abilities, cannot be trained in psionics';
trt(26,:)= 'resistant to diseases';
desc(26,:)= 'gives +2 DM End checks on infections and diseases';
trt(27,:)= 'resistant to fear';
desc(27,:)= 'gives +2 DM on skill checks against fear and intimidation';
trt(28,:)= 'resistant to poisons';
desc(28,:)= 'gives +2 DM on End checks against toxins and poisons';
trt(29,:)= 'resistant to psionics';
desc(29,:)= 'gives +2 DM against all psionics, cannot be trained in psionics';
trt(30,:)= 'spitting attack';
desc(30,:)= 'gives a short range, 1d6 acid attack using athletics skill';
trt(31,:)= 'unusual hand structure';
desc(31,:)= 'gives -1 DM for using instruments designed for humans';
trt(32,:)= 'major unusual life support requirement';
desc(32,:)= 'requires a particular substance or will die from dehydration equivalent';
trt(33,:)= 'minor unusual life support requirement';
desc(33,:)= 'requires a particular substance or will die from starvation equivalent';
trt(34,:)= 'unusual sleep cycle';
desc(34,:)= 'requires sleep on an irregular cycle- unable to adjust physiologically';
trt(35,:)= 'xenoempathy';
desc(35,:)= 'gives +2 DM on carouse rolls due to understanding other species';
trt(36,:)= 'alertness';
desc(36,:)= 'gives a +2 DM on perception based skill checks';
trt(37,:)= 'athletic';
desc(37,:)= 'gives a +2 DM on all athletics skill checks';
trt(38,:)= 'offensive stench';
desc(38,:)= 'causes anyone smelling to make an End check or have -1 DM until leaving the area';
trt(39,:)= 'closed book';
desc(39,:)= 'gives a -2 DM when being read or sensed by others';
trt(40,:)= 'eidetic memory';
desc(40,:)= 'gives perfect memory of previously obtained information';
trt(41,:)= 'fast talker';
desc(41,:)= 'gives +2 DM to verbal deception skill checks';
trt(42,:)= 'gearhead';
desc(42,:)= 'gives a +2 DM for mechanics repair checks';
trt(43,:)= 'bioelectric shock';
desc(43,:)= 'delivers a 1d6 electric shock by touch once per 12 hours';
trt(44,:)= 'haggler';
desc(44,:)= 'gives a +2 DM for any broker check';
trt(45,:)= 'interrogator';
desc(45,:)= 'gives a +2 DM for attempts to extract information from another being';
trt(46,:)= 'intolerant';
desc(46,:)= 'character must make an Int check or take offense at an insult';
trt(47,:)= 'natural advocate';
desc(47,:)= 'gives a +2 DM on advocate checks due to legal tendency';
trt(48,:)= 'natural born leader';
desc(48,:)= 'gives a +2 DM on leadership checks due to species charisma';
trt(49,:)= 'natural compass';
desc(49,:)= 'senses magnetic fields, giving a +2 DM on navigation checks on planets';
trt(50,:)= 'natural pilot';
desc(50,:)= 'gives a +2 DM on pilot checks due to 3D spatial perception';
trt(51,:)= 'natural survivalist';
desc(51,:)= 'gives a +2 DM on survival checks in natural settings';
trt(52,:)= 'natural thief';
desc(52,:)= 'gives a +2 DM on deception checks';
trt(53,:)= 'naturally honest';
desc(53,:)= 'gives a -4 DM when the sophont is telling a lie';
trt(54,:)= 'overly aggressive';
desc(54,:)= 'gives a +2 DM on initiative checks due to violent tendencies';
trt(55,:)= 'racial defense';
desc(55,:)= 'gives a +2 defense bonus in personal combat against a single race';
trt(56,:)= 'racial enemy';
desc(56,:)= 'gives a +1 attack bonus against a single racial enemy';
trt(57,:)= 'racial phobia';
desc(57,:)= 'forces a sophont to make an Int check to overcome their phobia';
trt(58,:)= 'racial weapon';
desc(58,:)= 'gives a +1 attack bonus when using a single historically important weapon';
trt(59,:)= 'well traveled';
desc(59,:)= 'gives a +2 DM on liason checks due to cultural familiarity';
trt(60,:)= 'trustworthy';
desc(60,:)= 'gives -2 DM to bribery, deception, and streetwise checks';
#                 
#                 
trt(63,:)= 'amphibious';
desc(63,:)= 'lives part time in land and water';
trt(64,:)= 'aquatic';
desc(64,:)= 'lives life entirely in the water- can leave for short periods';
trt(65,:)= 'burst of speed';
desc(65,:)= 'move 1.5 m/sec faster than stated speed for End minutes';
trt(66,:)= 'cold blooded';
desc(66,:)= 'gives a -2 DM initiative in cold envrionments; +2 DM vs being found by IR';
trt(67,:)= 'fast metabolism';
desc(67,:)= 'gives a +2 DM initiative, requires 2x life support costs';
trt(68,:)= 'deep diver';
desc(68,:)= 'allows air breathing sophont to dive as deep as 240m';
trt(69,:)= 'desert adaptation';
desc(69,:)= 'gives +2 DM for survival and navigation in desert environments';
trt(70,:)= 'feral';
desc(70,:)= 'uneducatable- roll 1d6 Edu only';
trt(71,:)= 'fragile';
desc(71,:)= 'suffers 1.5x more damage from blunt weapons';
trt(72,:)= 'gravity intolerance';
desc(72,:)= 'gives a -2 DM in normal gravity, -4 DM in high gravity';
trt(73,:)= 'heavy gravity adaptation';
desc(73,:)= 'automatically adapted to high gravity environments';
trt(74,:)= 'low gravity adaptation';
desc(74,:)= 'automatically adapted to low gravity environments';
trt(75,:)= 'slow metabolism';
desc(75,:)= 'gives a -2 DM to initiative, requires only 50% of life support costs';
trt(76,:)= 'stability';
desc(76,:)= 'gives +2 DM to resist forced movement when standing';
trt(77,:)= 'stalwart movement';
desc(77,:)= 'allows movement at full normal speed even when encumbered';
trt(78,:)= 'taint immunity';
desc(78,:)= 'unaffected by presence or absence of atmospheric taint';
trt(79,:)= 'taint breather';
desc(79,:)= 'requires atmospheric taint; treat stnd atmo as tainted';
trt(80,:)= 'trace breather';
desc(80,:)= 'can breathe trace atmospheres without difficulty, but cannot breathe dense atmospheres';
trt(81,:)= 'trace breather, limited';
desc(81,:)= 'allows safely breathing a trace atmosphere for up to 1 hr';
trt(82,:)= 'vacuum survival, limited';
desc(82,:)= 'allows sophont to live for 15 minutes in zero atmosphere safely';
trt(83,:)= 'water dependent';
desc(83,:)= 'sophont can only survive out of the water for 1 hr per 2 pts End';
trt(84,:)= 'atmospheric requirement';
desc(84,:)= 'sophont requires an atmosphere very similar to their own';
trt(85,:)= 'natural swimmer';
desc(85,:)= 'gives a +2 DM on all swimming related skill checks';
trt(86,:)= 'gendermorphic';
desc(86,:)= 'sophont can switch genders over 2d6 days under certain conditions';
trt(87,:)= 'no land movement';
desc(87,:)= 'species does not have an effective way to move around on land';
trt(88,:)= 'multiple limbs';
desc(88,:)= 'species gains one additional action with no penalty- racial multitasking';
trt(89,:)= 'slow speed';
desc(89,:)= 'species moves at a slower speed than humans (less than 6 m/sec)';
trt(90,:)= 'fast speed';
desc(90,:)= 'species moves at a faster speed than humans (more than 8 m/sec)';
trt(91,:)= 'armored';
desc(91,:)= 'species possesses a natural protective armor';
trt(92,:)= 'natural weapon';
desc(92,:)= 'species body has one or more 1d6 weapons as part of their body';
trt(93,:)= 'poisonous';
desc(93,:)= 'bite or stinger attack is poisonous, -1d6 End if End check is failed';
trt(94,:)= 'no vocal cords';
desc(94,:)= 'sophonts lack the physical ability to make vocal noises';
trt(95,:)= 'organic radio communication';
desc(95,:)= 'species can listen and transmit radio waves over 5km distances';
trt(96,:)= 'vibration sense';
desc(96,:)= 'species can detect shapes and locations without light using sound';
trt(97,:)= 'telepathy, limited';
desc(97,:)= 'allows 1.5m range mental communication with any creature with a language';
trt(98,:)= 'telepathy';
desc(98,:)= 'allows medium range mental communication with any creature with a language';
trt(99,:)= 'light sensitivity';
desc(99,:)= 'quick bright light causes blindness for 1 minute.  -1 DM operating in bright light';
trt(100,:)= 'color blindness';
desc(100,:)= 'sophont perceives the world in shades of gray';
trt(101,:)= 'low-light vision';
desc(101,:)= 'species can determine color and detail 2x farther than humans in low light';
trt(102,:)= 'IR vision';
desc(102,:)= 'species sees into the IR (heat) spectrum';
trt(103,:)= 'UV vision';
desc(103,:)= 'species sees into the UV spectrum- sees ionization, electric plasmas';

et1=['producer'; 'scavenger'; 'herbivore'; 'omnivore'; 'carnivore'];
etp=['passive'; 'supplementer'; 'trapper'; 'siren'; 'active'];
ets=['reducer'; 'hijacker'; 'intimidator'; 'carrion-eater'];
eth=['filter'; 'intermittent'; 'grazer'];
eto=['gatherer'; 'hunter'; 'eater'];
etc=['pouncer'; 'trapper'; 'chaser'; 'siren'; 'killer'];
breath=['do not need to breathe'; 'breathe air'; 'breathe water'; 'breathe air or water'];
siz=['tiny'; 'small'; 'average'; 'large'; 'huge']; 
gend=['asexual'; 'hermaphrodites'; 'have 2 genders'; 'have 3 genders'; 'have 4 genders'; 'have 5 genders'];
offsp=['by budding'; 'by bearing their young'; 'by laying eggs'];
symm=['radially'; 'bilaterally'; 'trilaterally'];


clear cbases
clear psystems
clear jumpsys
clear sys_ten

for j=1:cnt-1                      # cycle through all systems for accumulations
  stype(trav(j).starlocation+1)=stype(trav(j).starlocation+1)+1;
  snav=snav+trav(j).naval;
  ssco=ssco+trav(j).scout;
  said=said+trav(j).aid;
  scon=scon+trav(j).consul;
  for a=1:16
    st(a)=st(a)+trav(j).trade(a);
    endfor
  stech=stech+trav(j).tech;      #compile info about tech levels
  stl(trav(j).tech+1)=stl(trav(j).tech+1)+1;
  slaw=slaw+trav(j).law;         #compile info about law levels
  slaws(trav(j).law+1)=slaws(trav(j).law+1)+1;
  shab=shab+trav(j).habnum;

cbases(j)=-1*(((trav(j).scout==1)+(trav(j).naval==1)+(trav(j).consul==1))>0);
psystems(j)=-1*(trav(j).population>5);
jumpsys(j)=-1;
sys_ten(j)=-1*(trav(j).influ.self>9);
for a=1:length(tr)
  d=distance_array(trav(j).fullcount,a);
  if (d<7)
      psystems(j)=psystems(j)+((tr(a).population>5)*(d<(syst_weeklyreport-1))); # nearby million+ systems
      if (syst_pockets==1)   # nearby 10+ influence systems
          sys_ten(j)=sys_ten(j)+((d<syst_weeklyreport-1)*(tr(a).influ.self>9));
        endif
      b=max(0,((tr(a).tech-8)-(tr(a).tech>9)));
      jumpsys(j)=jumpsys(j)+(d<=b); # systems within jump range
      if (syst_confederation==1)
          b=((tr(a).scout==1)+(tr(a).naval==1)+(tr(a).consul==1))>0;
          cbases(j)=cbases(j)+(b*(d<syst_weeklyreport)); # bases reported to every week
        endif
    endif
  endfor
cbases(j)=cbases(j)*(((trav(j).scout==1)+(trav(j).naval==1)+(trav(j).consul==1))>0);  # must have a base 

if ((syst_confederation==1)*(syst_pockets==1))  
  ctst=trav(j).influ.confed-influence(trav(j)); # compile info about confederation influence
  if (ctst>15)
      mconf(5)=mconf(5)+1;
    elseif (ctst>5)
      mconf(4)=mconf(4)+1;
    elseif (ctst>-5)
      mconf(3)=mconf(3)+1;
    elseif (ctst>-14)
      mconf(2)=mconf(2)+1;
    else
      mconf(1)=mconf(1)+1;
    endif 
endif
    
  spop=spop+ (trav(j).population==0);
  whab(trav(j).habnum+1)= whab(trav(j).habnum+1)+1;  # count how many hab worlds per system
  for a=1:trav(j).habnum      #compile info about habitable worlds
    shabe=shabe+ (trav(j).habit.good(a)==3);
    shabs=shabs+ (trav(j).habit.good(a)==2);
    shabb=shabb+ (trav(j).habit.good(a)==1);
    sgeo=sgeo+ trav(j).geothermal(trav(j).habit.planet(a));
    if (trav(j).habit.moon>0)
        f=trav(j).moon.favor(trav(j).habit.planet(a),trav(j).habit.moon(a));
      else
        f=trav(j).favor(trav(j).habit.planet(a));
      endif
    savi=savi+ (f==1);
    sins=sins+ (f==2);
    smer=smer+ (f==3);
    srep=srep+ (f==4);
    stemps(trav(j).habit.temp(a))=stemps(trav(j).habit.temp(a))+1;
    ssizes(trav(j).habit.size(a)+1)=ssizes(trav(j).habit.size(a)+1)+1;  
    endfor
  sgovs(trav(j).govern+1)=sgovs(trav(j).govern+1)+1;  
  sstars=sstars+ trav(j).starnum;  
  for a=1:trav(j).starnum     #compile info about stars in system
    sred=sred+ (trav(j).startype(a,1)=='r');
    sora=sora+ (trav(j).startype(a,1)=='o');
    syel=syel+ (trav(j).startype(a,1)=='y');
    swhi=swhi+ (trav(j).startype(a,1)=='w');
    sbro=sbro+ (trav(j).startype(a,6)=='T');
    sdwf=sdwf+ (trav(j).startype(a,6)=='D');
    svar=svar+ (trav(j).period(2)>0);
    sgia=sgia+ ((trav(j).startype(a,6)=='A')+(trav(j).startype(a,6)=='B')+(trav(j).startype(a,6)=='S')+(trav(j).startype(a,6)=='O')+(trav(j).startype(a,6)=='W'));
    sfor=sfor+ ((trav(j).startype(a,1)=='T')+(trav(j).startype(a,1)=='p'));
    endfor
  svegs=svegs+ ((trav(j).tech<8)*(trav(j).population<4)*(trav(j).population>0)); # count vestigial worlds  
  sgdp=sgdp+ trav(j).gdp;
  gdpcnt(ceil((trav(j).gdp+1)/10000))=gdpcnt(ceil((trav(j).gdp+1)/10000)) +1;
  smoo=smoo+ (trav(j).bestm>0);
  amb=amb+ (trav(j).restriction==1);
  red=red+ (trav(j).restriction==2);
  sa=sa+(trav(j).starport=='A');
  sb=sb+(trav(j).starport=='B');
  sc=sc+(trav(j).starport=='C');
  sd=sd+(trav(j).starport=='D');
  se=se+(trav(j).starport=='E');
  sx=sx+(trav(j).starport=='X');

if (syst_pockets==1)  
  if (trav(j).influ.independent==1)                   #compile info on pocket empires
      spoc(poccnt).loc(1)=trav(j).sector(1);
      spoc(poccnt).loc(2)=trav(j).sector(2);
      spoc(poccnt).loc(3)= j;
      spoc(poccnt).name =trav(j).name;
      spoc(poccnt).number=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      spoc(poccnt).combined=length(trav(j).influ.dominate)+(trav(j).influ.dominate(1)>0);
      mpoc(ceil((spoc(poccnt).number+1)/5))=mpoc(ceil((spoc(poccnt).number+1)/5))+1;
      if (spoc(poccnt).number>1) # if they have an ally check to see if those have a pocket empire
          for a=1:length(trav(j).influ.dominate)
            b=trav(j).influ.ally(a,1);
            c=trav(j).influ.ally(a,2);
            d=trav(j).influ.ally(a,3);
            spoc(poccnt).combined= spoc(poccnt).combined+length(sys(b,c,d).influ.dominate)-1;
            if (sys(b,c,d).influ.dominate(1)>0)
                spoc(poccnt).combined=spoc(poccnt).combined+1;
              endif  
            endfor 
       endif
      cpoc(ceil((spoc(poccnt).combined+1)/5))=cpoc(ceil((spoc(poccnt).combined+1)/5))+1;
      poccnt=poccnt+1;
    elseif (trav(j).influ.dominate(1)>0)
      dpoc(dcnt).loc(1)=trav(j).sector(1);
      dpoc(dcnt).loc(2)=trav(j).sector(2);
      dpoc(dcnt).loc(3)= j;
      dpoc(dcnt).name =trav(j).name;
      dpoc(dcnt).number=length(trav(j).influ.dominate);
      mpoc(ceil(dpoc(dcnt).number/5))=mpoc(ceil(dpoc(dcnt).number/5))+1;
      dcnt=dcnt+1;
    endif
endif

spo=spo+ (trav(j).pop*10^trav(j).population); #compile information on populations
spops(trav(j).population+1)= spops(trav(j).population+1)+1;
snat=snat+ (trav(j).native>0);  

if (syst_popfind==1)    
  test=vertcat(trav(j).populate.pn)(:,1);
  tpp=vertcat(trav(j).populate.pp)(:,1);
  if (test(1)<990)
      for a=1:length(test)                     #compile racial information
        demop(test(a)+1)=demop(test(a)+1)+ ceil(trav(j).pop*(10^(trav(j).population-2))*tpp(a));
        demow(test(a)+1)=demow(test(a)+1)+1;
        endfor
    endif    
  endif

if (syst_confederation==1)
  vas=vas+ min(1,((trav(j).population<6)+(trav(j).tech<7)))*(trav(j).planets>0);
  obs=obs+ ((trav(j).population>5)*(trav(j).tech>6)) - ((trav(j).population>6)*(trav(j).tech>8));
  c= ((trav(j).population==10)*(trav(j).tech>12))+ ((trav(j).population==9)*(trav(j).tech==15));
  adv=adv+ c;
  mem=mem+ ((trav(j).population>6)*(trav(j).tech>8))- c;
endif

if ((syst_personalities==1)*(trav(j).population>0))  # count through personality array and find those with stronger opinions
    for a=1:15
      personal(a,1)=personal(a,1)+ (trav(j).personality(a)<6);
      personal(a,2)=personal(a,2)+ ((trav(j).personality(a)>9)*(trav(j).personality(a)<16));
    endfor
endif
 
  endfor  

# print a subsector summary for all systems and overall subsector stats


# open the subsector file for printing
chdir(newdir);
namefile= strcat('S', num2str(trav(1).sector(1)), ',', num2str(trav(1).sector(2)), trav(1).subsectname,'.html');
fid= fopen(namefile, "at");
printf("printing %s.\n", namefile);
fflush(stdout);

# fid=stdout;
fprintf(fid, "<!DOCTYPE html>");
fprintf(fid, "<html>\n");
fprintf(fid, "<head>\n");
fprintf(fid, "<title>%s</title>\n",trav(1).subsectname(:));
fprintf(fid, "<link href=\"%s.css\" type=\"text/css\" rel=\"stylesheet\" />\n",newdir);
fprintf(fid, "</head>\n");
fprintf(fid, "<body>\n");
tref=strcat('S',num2str(trav(1).sector(1)), ',', num2str(trav(2).sector(2)), trav(1).subsectname, ".",syst_imagetype);

fprintf(fid, "<h1><a name=\"list\">Subsector</a> <a href=\"%s\" target=\"_blank\">[%d,%d]</a> %s of %s Setting</h1>\n", tref, trav(1).sector(1), trav(1).sector(2), trav(1).subsectname(:), newdir);
fprintf(fid, "<table class=\"planets\" cellpadding=\"1\"><tr>");
fprintf(fid, "<th>##</th><th>System name</th><th>Loc</th><th>prim UWP</th>\n");
if (syst_confederation==1)
    fprintf(fid, "<th>Nav</th><th>Sco</th><th>Con</th>\n");
  endif
if (syst_explorer==1)
    fprintf(fid, "<th>Aid</th>");
  endif
fprintf(fid,"<th>Res</th><th>Plan</th><th>Gia</th><th>Ast</th><th>Habit</th>\n");
if (syst_race<13)
    fprintf(fid,"<th>Native</th>");
  endif
if (syst_hierarchy==1)
    fprintf(fid,"<th>Confed</th>");
  endif
fprintf(fid,"<th>GDP</th><th>Trade</th></tr>\n");

for a=1:cnt-1
  if (trav(a).bestm==0)
      uwp=trav(a).uwp(trav(a).bestp,:);
    else
      for b=1:9
        uwp(b)=trav(a).moon.uwp(trav(a).bestp, trav(a).bestm,b);
        endfor
    endif  
  tref=strcat('S',num2str(trav(a).sector(1)), ',', num2str(trav(a).sector(2)), trav(a).subsectname, ".html#", trav(a).name);
  tref2=strcat('S',num2str(trav(a).sector(1)), ',', num2str(trav(a).sector(2)), trav(a).subsectname, ".", syst_imagetype);
  fprintf(fid, "<tr><td>%4d</td>\n<td><a href=\"%s\">%s</a></td>\n<td>%2d,%2d</td>\n<td>%s</td>\n", a, tref, trav(a).name, trav(a).subsector(1), trav(a).subsector(2), uwp(:)); 
  if (syst_confederation==1)
      fprintf(fid, "<td>%s</td>\n<td>%s</td>\n<td>%s</td>", present(trav(a).naval+1), present(trav(a).scout+1), present(trav(a).consul+1));
    endif
  if (syst_explorer==1)
      fprintf(fid,"<td>%s</td>", present(trav(a).aid+1));
    endif
  fprintf(fid, "<td>%s</td><td>%2d</td><td>%d</td><td>%d</td><td>%2d</td>", rescode(trav(a).restriction+1), trav(a).planets, trav(a).giants, trav(a).asteroids, trav(a).habnum);
  if (syst_race<13)
      fprintf(fid, "<td>%s</td>", present((trav(a).native>0)+1));
    endif
  if (syst_hierarchy==1)
      fprintf(fid,"<td>%5s</td>\n", confed(trav(a).confed+1,:));
    endif  
  fprintf(fid,"<td align=\"right\">&nbsp; %5s &nbsp;</td><td align=\"left\">", num2str(trav(a).gdp));
  for b=1:16
    if (trav(a).trade(b)>0)
        fprintf(fid, "%s, ", tradecodes(b,:));
      endif
    endfor  
  fprintf(fid, "</td></tr>\n");    
  endfor
fprintf(fid, "</table><br>\n");
 
fprintf(fid, "<p><a href=\"%s\">Return to Setting Summary</a></p><hr width=\"100%%\" align=\"center\"><br>\n", [newdir, "_summary.html"]);
  
fprintf(fid, "<h2>Subsector Overview</h2>\n");
if (syst_confederation==1)
    fprintf(fid, "\n<p><strong>Naval bases:</strong> %d &nbsp;&nbsp;&nbsp;   <strong>Scout bases:</strong> %d &nbsp;&nbsp;&nbsp;   <strong>Consulates:</strong> %d</p>\n", snav, ssco, scon);
    clear cbasetotal;
    b=1;
    for a=1:length(trav)
      if (cbases(a)>0);
          cbasetotal(b)=cbases(a);
          cbasetrans(b)=a;
          b=b+1;
        endif
      endfor
    fprintf(fid,"<p>The Confederation has bases in %d of %s's %d systems.<\p>", b-1, trav(1).subsectname(:), length(trav));
    if (b>0)
        a=sum(cbases(:))/b;
        fprintf(fid, "<p>On average each base in this subsector contacts %2.3d other bases within %d parsecs every week.<br>\n",a, syst_weeklyreport-1);   
        [a b]= max(cbases(:));
        [c d]= min(cbasetotal(:));
        fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, trav(b).name(:), c, trav(cbasetrans(d)).name); 
      endif
  endif
fprintf(fid, "\n<p><strong>Starports:</strong> &nbsp;&nbsp; <strong>A:</strong> %d &nbsp;&nbsp;&nbsp; <strong> B:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>C:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>D:</strong> %d &nbsp;&nbsp;&nbsp; <strong> E:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>X:</strong> %d",sa, sb, sc, sd, se, sx);
if (syst_explorer==1)
    fprintf(fid, " &nbsp;&nbsp;&nbsp; <strong> Explorer's Hostels:</strong> %d</p>\n", said);
  else
    fprintf(fid, "</p>\n");
  endif  
fprintf(fid, "\n<p><strong>avg tech:</strong> %.3d &nbsp;&nbsp;&nbsp; <strong>avg law:</strong> %.3d &nbsp;&nbsp;&nbsp; <strong>avg number of habitable worlds:</strong> %.3d &nbsp;&nbsp;&nbsp;  <br><br><strong>avg GDP/system:</strong> %5d Cr &nbsp;&nbsp;&nbsp; <strong>uninhabited systems:</strong> %d  &nbsp;&nbsp; <strong>vestigial:</strong> %d &nbsp;&nbsp;  <strong>amber:</strong> %d &nbsp;&nbsp; <strong>red:</strong> %d</p>\n", (stech/(cnt-1)), (slaw/(cnt-1)), (shab/(cnt-1)), (sgdp/(cnt-1)), spop, svegs, amb, red);
fprintf(fid, "<p><strong>Total Stars:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>red type M:</strong> %d &nbsp;&nbsp;&nbsp; <strong>orange type K:</strong> %d &nbsp;&nbsp;&nbsp; <strong>yellow type G:</strong> %d &nbsp;&nbsp;&nbsp; <strong>white type F:</strong> %d</p>\n", sstars, sred, sora, syel, swhi);
fprintf(fid, "<p><strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;<strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;<strong>&nbsp;&nbsp;&nbsp;%s:</strong> %d &nbsp;&nbsp;&nbsp;", stypesize(2,:), stype(2), stypesize(3,:), stype(3), stypesize(4,:), stype(4));
fprintf(fid, "\n<p>&nbsp;&nbsp;&nbsp; <strong>type D white dwarf:</strong> %d &nbsp;&nbsp;&nbsp; <strong>type T brown dwarf:</strong> %d &nbsp;&nbsp;&nbsp;<strong>giant stars:</strong> %d &nbsp;&nbsp;&nbsp; <strong>variable stars:</strong> %d &nbsp;&nbsp;&nbsp; <strong>forming stars:</strong> %d</p>", sdwf, sbro, sgia, svar, sfor);
fprintf(fid, "\n<p><h2> World and System Summaries</h2></p>\n");
fprintf(fid, "<p><strong>easily habitable:</strong> %d &nbsp;&nbsp; <strong>semi-habitable:</strong> %d &nbsp;&nbsp; <strong>barely habitable:</strong> %d &nbsp;&nbsp; <strong>geothermally habitable:</strong> %d</p>\n", shabe, shabs, shabb, sgeo);
if (syst_race<13)
    fprintf(fid, "<p><strong>homeworlds:</strong> %d &nbsp;&nbsp;&nbsp;  ", snat);
  endif
if (syst_favorable==1)
    fprintf(fid, "<strong>avian favored:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>insectan favored:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>merfolk favored:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>reptilian favored:</strong> %d</p>\n", savi, sins, smer, srep);
  else
    fprintf(fid, "</p>\n");
  endif 
a=sum(psystems(:))/length(trav);
fprintf(fid, "<p>In this subsector there are an average of %2.2d systems within %d parsecs that have populations of at least 1 million.<br>\n",a, syst_weeklyreport-2);   
[a b]= max(psystems(:));
[c d]= min(psystems(:));
fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, trav(b).name(:), c, trav(d).name(:)); 
a=sum(jumpsys(:))/length(trav );
fprintf(fid, "<p>On average there are %2.2d systems which have a technology level allowing them to jump to a particular world in this subsector.<br>\n",a);   
[a b]= max(jumpsys(:));
[c d]= min(jumpsys(:));
fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, trav(b).name(:), c, trav(d).name(:)); 
 
fprintf(fid, "\n<table border=\"1\" cellpadding=\"3\"><tr><td valign=\"top\"><h2>Habitable World<br>Temperatures</h2>\n<ul>");
for a=3:9
  fprintf(fid, "<li> <strong>%s:</strong> %d </li>\n", strtrim(tempstring(a,:)), stemps(a-2));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>Habitable<br>World Sizes</h2>\n<ul>");  
for a=1:11
  fprintf(fid, "<li><strong>siz%d:</strong> %d</li>\n", (a-1), ssizes(a));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>System Population</h2>\n<ul>");
  for a=1:11
  fprintf(fid, "<li><strong>pop #%d:</strong> %d</li>\n",(a-1),spops(a));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>System GDP<br>per Person</h2>\n<ul>");
  for a=1:10
  fprintf(fid, "<li> <strong>%d-%dK:</strong> %d</li>\n",(a-1)*10,a*10, gdpcnt(a));
  endfor

fprintf(fid, "</ul></td>\n</table><br>\n<table border=\"1\" cellpadding=\"3\"><tr><td valign=\"top\"><h2>Habitable Worlds<br> per System</h2>\n<ul>");
while (whab(end)==0)
    whab=whab(1:end-1);
  endwhile 
for a=1:length(whab)
  fprintf(fid, "<li> <strong>%d worlds:</strong> %d </li>\n",(a-1), whab(a));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>Trade Codes:</h2>\n<ul>");
for a=1:16
  fprintf(fid, "<li> <strong>%s:</strong> %d </li>\n",tradecodes(a,:), st(a));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>Tech Levels</h2>\n<ul>")  
for a=1:16
  fprintf(fid, "<li> <strong>TL%d:</strong> %d</li>\n",(a-1), stl(a));
  endfor
fprintf(fid, "</ul></td>\n<td valign=\"top\"><h2>System Law Levels:</h2>\n<ul>")
for a=1:10
  fprintf(fid, "<li> <strong>law %d:</strong> %d</li>\n", (a-1), slaws(a));
  endfor

  fprintf(fid, "</ul></td></tr>\n</table><br>\n<p><h2>Systems have the following types of local governments:</h2></p>\n<ul>")
for a=1:14
  fprintf(fid, "<li><strong>%s:</strong> %d \n</li>", strtrim(govstring(a,:)), sgovs(a));
  endfor
if (syst_hierarchy==1)
    fprintf(fid, "</ul>\n<p><h2>Confederation Planetary System Status</h2></p>\n<p><strong>frontier worlds:</strong> %d  &nbsp;&nbsp;&nbsp; <strong>observer worlds:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>member worlds:</strong> %d &nbsp;&nbsp;&nbsp;  <strong>advisory worlds:</strong> %d</p>\n",vas, obs, mem, adv);
  endif
if (syst_confederation==1)  
    fprintf(fid, "\n<p><h2>Confederation vs. Local influence standing is: </h2></p>\n<p>");
    for a=1:5
      fprintf(fid, "<strong>%s:</strong> %d &nbsp;&nbsp;&nbsp; ",strtrim(mconfstring(a,:)), mconf(a));
      endfor
    fprintf(fid, "</p>\n");  
  endif
  
if (syst_pockets==1)  
    fprintf(fid,"<h3>There are %d independent pocket empires in this subsector.</h3>\n<ul>", (poccnt-1));
    for a=1:poccnt-1
      fprintf(fid, "<li><a href=\"#%s\">%s</a> influences %d systems directly", spoc(a).name, spoc(a).name, spoc(a).number);
      if (spoc(a).combined>spoc(a).number)
          fprintf(fid, " and %d systems overall.</li>\n", spoc(a).combined);
        else
          fprintf(fid, ".</li>\n");
        endif  
      endfor
    fprintf(fid,"</ul><br>\n<h3>There are %d allied worlds with their own pocket empires in this subsector.</h3>\n<ul>", (dcnt-1));   
    for a=1:dcnt-1
      fprintf(fid, "<li><a href=\"#%s\">%s</a> has a pocket empire of %d worlds.</li>\n", dpoc(a).name, dpoc(a).name, dpoc(a).number);
      endfor
    fprintf(fid,"</ul><br>\n");  
    a=sum(sys_ten(:))/length(trav);
    fprintf(fid, "<p>In this subsector there are on average %2.2d systems within %d parsecs that have a base influence of 10 or more.<br>\n",a,syst_weeklyreport-2);   
    [a b]= max(sys_ten(:));
    [c d]= min(sys_ten(:));
    fprintf(fid, "&nbsp; &nbsp; The number ranges from %d for %s to %d for %s.</p>\n", a, trav(b).name(:), c, trav(d).name(:)); 
  endif

if (syst_personalities==1)
    fprintf(fid,"<h2>System Personality Traits</h2>\n");
    fprintf(fid, "<table cellpadding=\"0\" cellborder=\"1\"><tr>");
    fprintf(fid, "<td><h3>Against</h3></td><td align=\"center\"><h3> Trait </h3></td><td><h3> For </h3></td></tr>\n");
    for a=1:15
      if (a!=10)
         fprintf(fid, "<tr><td align=\"center\">%d</td><td align=\"center\"><strong> %s </strong></td><td align=\"center\">%d</td></tr>\n", personal(a,1), ptypes(a,:), personal(a,2));      
        endif
      endfor
    fprintf(fid, "</table>\n");
  endif

fprintf(fid,"<p><h2>People</h2></p>\n<p><h3>A total of %.3e sophonts live in this subsector.</h3></p>\n<ul>", spo);

if (syst_popfind==1)
for a=1:9
  if (demop(a)>0)
      fprintf(fid, "<li>%.2e %ss live in %d systems.</li>\n", demop(a), strtrim(nm(a,:)), demow(a));
    endif
  endfor 
if (exist('newrace.mat')==2)
  for a=11:(length(newrace)+11)
    if (demop(a)>0)
        tref=strcat('S',num2str(newrace(a-11).race.sector(1)), ',', num2str(newrace(a-11).race.sector(2)), newrace(a-11).race.subsectname, ".html#", newrace(a-11).race.name);
        fprintf(fid, "<li>%.2e <a href=\"%s\">%ss</a> live in %d systems. ", demop(a), tref, strtrim(newrace(a-11).race.name), demow(a));
        hometrunc=strtrunc(newrace(a-11).race.homeworld, index(newrace(a-11).race.homeworld, "-")-1);
        tref=strcat('S',num2str(newrace(a-11).race.sector(1)), ',', num2str(newrace(a-11).race.sector(2)), newrace(a-11).race.subsectname, ".html#", hometrunc);
        tref2=strcat('S',num2str(newrace(a-11).race.sector(1)), ',', num2str(newrace(a-11).race.sector(2)), newrace(a-11).race.subsectname, ".", syst_imagetype);
        fprintf(fid, "Their homeworld is <a href=\"%s\">%s</a> in the <a href=\"%s\" target=\"_blank\">%s subsector</a>.</li>\n", tref, strtrim(newrace(a-11).race.homeworld), tref2, strtrim(newrace(a-11).race.subsectname));
      endif
    endfor
  endif  
endif
fprintf(fid, "</ul><hr width=\"50%%\" align=\"left\">\n");  

# print out summary of all native sophont races to this subsector
natprint=0;
if (exist('newrace.mat')==2)  
fprintf(fid, "\n<p><h2>There are %d native races in this subsector.</h2></p>\n", snat);  
for j=1:cnt-1
  if (trav(j).native>0)
      race=trav(j).race;
      natprint=natprint+1;
      if (race.ecotype(1)==1)
          et=etp(race.ecotype(2),:);
        elseif (race.ecotype(1)==2)
          et=ets(race.ecotype(2),:);
        elseif (race.ecotype(1)==3)
          et=eth(race.ecotype(2),:);
        elseif (race.ecotype(1)==4)
          et=eto(race.ecotype(2),:);
        elseif (race.ecotype(1)==5)
          et=etc(race.ecotype(2),:);
        endif
      et=strtrim(et);
      tworld= trav(j).native;
      if (trav(j).habit.moon(tworld)==0)   # get homeworld info whether moon or planet
          hstring=trav(j).uwp(trav(j).habit.planet(tworld),:);
        else
          for a=1:9
            hstring(a)=trav(j).moon.uwp(trav(j).habit.planet(tworld),trav(j).habit.moon(tworld),a);
            endfor
          hstring=char(hstring);
        endif   
      fprintf(fid, "<p><h3><a name=\"%s\">%s</a></h3></p>\n", strtrim(race.name(:)), strtrim(race.name(:)));  
      hometrunc=strtrunc(race.homeworld, index(race.homeworld, "-")-1);      
      fprintf(fid, "<p>The %ss of <a href=\"#%s\">%s</a> (UWP %s) are derived from %s-%s stock.<br>\n", strtrim(race.name(:)), hometrunc, strtrim(race.homeworld(:)), hstring, strtrim(et1(race.ecotype(1),:)),et);
      tref=strcat('S',num2str(race.sector(1)), ',', num2str(race.sector(2)), race.subsectname, ".", syst_imagetype);
      fprintf(fid, "%s is located in the <a href=\"%s\" target=\"_blank\">[%d,%d] %s subsector</a> at location X-%d Y-%d.<br>\n", race.homename, tref, race.sector(1), race.sector(2), race.subsectname, race.subsector(1), race.subsector(2)); 
      fprintf(fid, "They %s and are %s in size, standing %d+%dd6 cm tall and weighing %d+%dd6 kg.<br>\n",strtrim(breath(race.breathe+1,:)), strtrim(siz(race.size,:)), race.height(1), race.height(2),race.weight(1),race.weight(2));
      fprintf(fid, "They are %s symmetric, %s, and reproduce %s.</p>\n", strtrim(symm(race.symmetry,:)), strtrim(gend(race.gender+1,:)), strtrim(offsp(race.reproduction,:)));
      fprintf(fid, "<p>They have %d limbs,", race.limbs);
      if (race.limbs==race.dual)
          fprintf(fid, " all");
        endif  
      if (race.dual>0)
          fprintf(fid, " %d of which can be used as arms or legs.<br>\n", race.dual);
        else
          fprintf(fid, " %d of which are arms and %d of which are legs.<br>\n", race.arms, race.legs);  
        endif
      fprintf(fid, "Using their limbs, they are ");
      if (race.land==0)
          fprintf(fid, "unable to effectively move on land.</p>\n");
        else
          fprintf(fid, "able to move at %d meters per second on land.</p>\n", race.land);
        endif  
      wing=race.limbs-race.dual-race.arms-race.legs;
      if (wing==0)
          meth='lighter than air gasses';
        else
          wing=wing/race.symmetry;
          meth=strcat(num2str(wing),' set(s) of wings');
        endif  
      if (race.flier>0)
          fprintf(fid, "<p>The race is able to fly at %d m/sec using %s.</p>\n", race.flys, meth);
        endif
      if (race.swimmer>0)
          fprintf(fid, "<p>The race is at home in the water and able to swim at %d m/sec.</p>\n", race.swims);  
        endif
      if (race.burrow>0)
          fprintf(fid, "<p>The race is also able to burrow through the ground at %d m/min.</p>\n", race.digs);
        endif
      if (race.climber>0)
          fprintf(fid, "<p>The race is also able to climb remarkably well, climbing at %d m/sec.</p>\n", race.climbs);
        endif
      fprintf(fid, "\n<p>The race matures at age %d, has %d years in its prime, then begins aging with a ", race.aging(1), race.aging(2));
      if (race.aging(3)>0)
          fprintf(fid, "+");
        endif
      fprintf(fid, "%d DM modifier.</p>\n", race.aging(3));
      fprintf(fid, "<p>Their primary characteristic scores are:<br>\n"); 
      fprintf(fid, "<h3>Str: %dd6",race.str(1));
      if (race.str(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.str(2));
        elseif (race.str(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.str(2));
        endif
      fprintf(fid, "Dex: %dd6",race.dex(1));
      if (race.dex(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.dex(2));
        elseif (race.dex(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.dex(2));
        endif
      fprintf(fid, "End: %dd6",race.endu(1));
      if (race.endu(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.endu(2));
        elseif (race.endu(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.endu(2));
        endif
      fprintf(fid, "Int: %dd6",race.int(1));
      if (race.int(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.int(2));
        elseif (race.int(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.int(2));
        endif
      fprintf(fid, "Edu: %dd6",race.edu(1));
      if (race.edu(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.edu(2));
        elseif (race.edu(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.edu(2));
        endif
      fprintf(fid, "Soc: %dd6",race.soc(1));
      if (race.soc(2)>0)
          fprintf(fid, "+%d &nbsp;&nbsp;&nbsp;",race.soc(2));
        elseif (race.soc(2)==0)
          fprintf(fid, " &nbsp;&nbsp;&nbsp; ");
        else
          fprintf(fid, "%d &nbsp;&nbsp;&nbsp;",race.soc(2));
        endif
      fprintf(fid, "Psi: %dd6",race.psy(1));
      if (race.psy(2)>0)
          fprintf(fid, "+%d</h3></p>\n",race.psy(2));
        elseif (race.psy(2)==0)
          fprintf(fid, "</h3></p>\n");
        else
          fprintf(fid, "%d</h3></p>\n",race.psy(2));
        endif
 
      if (race.armor>0)
          fprintf(fid, "<p>They possess %d points of natural armor.<br>\n", race.armor);
        endif
      if (length(race.weapon)>4)
          fprintf(fid, "They have %s which cause d6 extra damage points per hit plus Str modifier.<br>\n", race.weapon);
        endif
      vis=['absent'; 'worse than human'; 'human norm'; 'better than human'];
      fprintf(fid, "In terms of senses, their vision is %s, hearing is %s, and scent is %s.</p>\n\n",strtrim(vis(race.vision+1,:)), strtrim(vis(race.hearing+1,:)), strtrim(vis(race.scent+1,:))); 
      fprintf(fid, "<p>These sophonts have the following special traits:</p>\n<ul>");
      for a=1:race.traits
        t=strvcat(trt(race.trait(a),:));
        d=strvcat(desc(race.trait(a),:));
        fprintf(fid, "<li>   %s: %s</li>\n",t,d);
        endfor
      fprintf(fid, "</ul>\n");  
      if (natprint<snat)
          fprintf(fid, "<hr width=\"30%%\" align=\"left\">\n");
        endif
    endif
  endfor  
endif
fprintf(fid, "</ul><hr width=\"50%%\" align=\"left\">\n");  
 
fprintf(fid, "\n<h2>Individual System Descriptions</h2>\n");

for j=1:cnt-1            #cycle through the entire subsector

  sy= trav(j);
  # print out system summary
  tref=strcat('S',num2str(trav(1).sector(1)), ',', num2str(trav(2).sector(2)), trav(1).subsectname, ".", syst_imagetype);
  fprintf(fid, "<h3><a name=\"%s\">%d.</a> %s at location <a href=\"%s\" target=\"_blank\">X-%d, Y-%d.</a></h3>\n", sy.name(:), j, sy.name(:), tref, sy.subsector(1), sy.subsector(2)); 
  fprintf(fid, "<p>It has %d",sy.starnum);
  if (sy.starlocation==0)
      fprintf(fid, " %s star.<br>\n", strtrim(sy.startype(1,:)));
      fprintf(fid, "The jump shadow of this star extends %d million kilometers from the center of the star.<br>\n", ceil(140*sy.grav(1)));
    elseif (sy.starlocation==1)    
      fprintf(fid, " stars, a %s star and a %s star, which closely orbit one another at a distance of %d million km.<br>\n", strtrim(sy.startype(1,:)), strtrim(sy.startype(2,:)), sy.closeorbit);
      fprintf(fid, "The jump shadow of this binary system extends %d million kilometers from the largest star.<br>\n", ceil(140*sy.grav(1)));
    elseif (sy.starlocation==2)
      fprintf(fid, " stars, a %s star and a %s star, which distantly orbit one another %d million km apart.<br>\n", strtrim(sy.startype(1,:)), strtrim(sy.startype(2,:)), sy.distantorbit);
      fprintf(fid, "The primary's shadow extends %d million km and the companion's jump shadow extends %d million km.<br>\n", ceil(140*sy.grav(1)), ceil(140*sy.grav(2)));
    elseif (sy.starlocation==3)
      fprintf(fid, " stars, a %s and %s star closely orbiting one another at %d million km.<br>  A %s star is a distant companion to this pair orbiting the binary at %d million km.<br>\n", strtrim(sy.startype(1,:)), strtrim(sy.startype(2,:)), sy.closeorbit, strtrim(sy.startype(3,:)), sy.distantorbit);
      fprintf(fid, "The jump shadow of the binary pair extends %d million km from the largest star. The distant companion's jump shadow is %d million km.<br>\n", ceil(140*sy.grav(1)), ceil(140*sy.grav(3)));
    endif
# special text for odd types of stars
if (trav(j).startypenum>6)
    if (trav(j).period(2)>0)
        if (trav(j).period(1)==0)
            fprintf(fid,"This is an irregular variable star with a period measured in %s.<br>\n",perstring(trav(j).period(2),:));
            fprintf(fid,"There is an extensive debris field encircling the star.<br>\n");
          else
            fprintf(fid,"This is a regular variable star with a period of approximately %d %s.<br>\n", trav(j).period(2), perstring(trav(j).period(1),:));
            fprintf(fid,"There is an extensive debris field encircling the star.<br>\n");
          endif
      endif
    if (trav(j).startype(1,6)=='D')
        fprintf(fid, "This stellar reminant is surrounded by a colorful planetary nebula and an extensive debris field.<br>\n");
      endif
    if (trav(j).startype(1,1)=='p')
        fprintf(fid, "The bulging disk of primal particles spin rapidly near the center with decreasing quantities of <br>gas and dust as you head out to the distant reaches of this future solar system.<br>\n");
      endif
    if (trav(j).startype(1,6)=='T')
        fprintf(fid,"This lonely failed star sits silently in the blackness of space.<br>\n");
      endif
    d=((trav(j).startype(1,6)=='A')+(trav(j).startype(1,6)=='B')+(trav(j).startype(1,6)=='S')+(trav(j).startype(1,6)=='O')+(trav(j).startype(1,6)=='W'));
    if (d>0)
        fprintf(fid,"This giant star sits alone, having blasted away all remnants of possible planets millenia ago.<br>\n");
      endif
    if (trav(j).startype(1,6)=='N')
        fprintf(fid, "Composed of the densest known matter, neutron stars are deadly to approach.<br>\n");
      endif
  endif
  
fprintf(fid, "There are %d total planets, with %d giant planets and %d asteroid belts in this system.<br>\n", sy.planets, sy.giants, sy.asteroids);
if ((trav(j).startypenum<5)+((trav(j).startypenum<7)*(trav(j).starnum>1)))
    if (sy.planets==sy.companions)
        fprintf(fid, "All of the planets are in orbit about the distant companion star.<br>\n");
      elseif (sy.companions==0)
        if (sy.starlocation==0)
            temp="primary star";
          elseif ((sy.starlocation==1)+(sy.starlocation==3))
            temp="binary pair in a P-type circumbinary orbit";
          elseif (sy.starlocation==2)
            temp="larger primary star in an S-type orbit";
          endif
        fprintf(fid, "All of the planets are in orbit around the %s.<br>\n", temp(:));
      else
        if (sy.starlocation==0)
            temp="primary star";
          elseif ((sy.starlocation==1)+(sy.starlocation==3))
            temp="binary pair in a P-type circumbinary orbit";
          elseif (sy.starlocation==2)
            temp="larger primary star in an S-type orbit";
          endif
        fprintf(fid, "%d planets are found around the %s and %d planets are orbiting the distant companion star.<br>\n", (sy.planets-sy.companions), temp, sy.companions);     
      endif
  endif

if (sy.starlocation>1)
    fprintf(fid, "It takes roughly %d hours at 1g to travel from the primary star to the distant companion.<br>\n", ceil((2*(sy.distantorbit*100000000)^.5)/3600));
  endif
fprintf(fid, "The best starport in the system is %s and there are %d potentially habitable worlds overall.</p>\n", sy.starport, sy.habnum);
fprintf(fid, "<p>%.1fx10^%d sophonts live in the system under law level %d and they have an average tech level of %s.<ul>\n", sy.pop, sy.population, sy.law, dec2hex(sy.tech));
if ((trav(j).tech<8)*(trav(j).population<4)*(trav(j).population>0))
    fprintf(fid, "<li><span style=\"background-color: #c0c0ff\">This is a vestigial population, and is slowly disappearing.</span></li>\n");
  endif 
if (syst_popfind==1)  
    new=sy.populate;
    if (sy.population>0)
        for a=1:length(new)
          if (new(a).pn>10)
              hometrunc=strtrunc(newrace(new(a).pn-10).race.homeworld, index(newrace(new(a).pn-10).race.homeworld, "-")-1);
              tref=strcat('S',num2str(newrace(new(a).pn-10).race.sector(1)), ',', num2str(newrace(new(a).pn-10).race.sector(2)), newrace(new(a).pn-10).race.subsectname, ".html#", hometrunc);
              tref2=strcat('S',num2str(newrace(new(a).pn-10).race.sector(1)), ',', num2str(newrace(new(a).pn-10).race.sector(2)), newrace(new(a).pn-10).race.subsectname, ".", syst_imagetype);
              tref3=strcat('S',num2str(newrace(new(a).pn-10).race.sector(1)), ',', num2str(newrace(new(a).pn-10).race.sector(2)), newrace(new(a).pn-10).race.subsectname, ".html#", strtrim(new(a).pname));
              fprintf(fid, "<li>%d percent of the population is <a href=\"%s\">%s</a>.", new(a).pp, tref3, strtrim(new(a).pname));
              fprintf(fid, " Their homeworld is <a href=\"%s\">%s</a> in the <a href=\"%s\" target=\"_blank\">%s subsector.</a></li>\n", tref, strtrim(newrace(new(a).pn-10).race.homeworld), tref2, strtrim(newrace(new(a).pn-10).race.subsectname));
            else
              fprintf(fid, "<li>%d percent of the population is %s.</li>\n", new(a).pp, strtrim(new(a).pname));
            endif  
          endfor
          fprintf(fid, "</ul>\n");
        else
          fprintf(fid, "</ul>\n");
        endif
  else
    fprintf(fid, "</ul>\n");  
  endif
if ((syst_popcenter==1)*(sy.population>0))     # print out the number of 'major' settlements in the system
    fprintf(fid, "<p>The major settlements of this system are:</p><ul>\n");     
    for a=1:length(sy.popcenter)
      if (sy.popcenter(10-a)>0)         # only print if non-zero
          fprintf(fid, "<li>%d %s of sophonts.</li>\n",sy.popcenter(10-a), strtrim(centerstring(10-a,:)));
        endif
      endfor
    fprintf(fid, "</ul>\n");
  endif  
if (sy.population>0)
    fprintf(fid, "<p>The average sophont earns about %d credits and the overall system GDP is %.2e MCr.<br>\n", (round(sy.gdp/100)*100), ((round(sy.sysgdp/100)*100)/1000000));  
  endif
  
if (syst_factions==1)
    fprintf(fid, "Overall there is %s in charge of the system with %d factions present.<ul>", strtrim(govstring((sy.govern+1),:)), sy.factions);
    for a=2:(sy.factions+1)
      fprintf(fid, "<li>one faction has %s strength</li>\n", strtrim(facstring(sy.faction(a),:)));
      endfor
    fprintf(fid, "</ul></p>\n");
  endif
  
if ((sy.population>0)*(syst_personalities==1))
    fprintf(fid, "<p>The sophonts in this system have the following general attitudes on a scale of 0 to 15:</p>\n<ul>");
    for a=1:15
      if (a!=10)  # remove 'order' from system personalities- redundant with law level
          perdesc=floor((sy.personality(a)/2)+1);
          fprintf(fid, "<li>%s: %d &nbsp&nbsp %s</li>\n", ptypes(a,:), sy.personality(a), pdesc(perdesc,:));
        endif
      endfor
    fprintf(fid, "</ul></p>\n");
  endif  

chdir(olddir);  
influj=influence(trav(j));  
chdir(newdir);
if (syst_hierarchy==1)
    fprintf(fid, "<p>Based on the population and tech level, %s is considered %s system.<\p>\n", trav(j).name(:), strtrim(confedstring(sy.confed,:)));
  endif

if ((syst_confederation==1)*(syst_pockets==1))  
    fprintf(fid, "<p>%s has an individual influence of %d, and the Confederation has an influence of %d.<br>\n", trav(j).name(:), influj, trav(j).influ.confed);
    if ((trav(j).govern==6)*(trav(j).influ.confed>=trav(j).influ.score(1)))
        fprintf(fid, "  The Confederation is in control of %s's captive government.<br>\n", trav(j).name);
      endif  
endif
  

if (syst_pockets==1)
if (syst_confederation==0)
    fprintf(fid, "<p>%s has an influence score of %d relative to its neighbors.<br>\n", trav(j).name(:), influj);
  endif  
if (trav(j).influ.independent==1)
    fprintf(fid, "&nbsp&nbsp&nbsp  %s is independent of control from any nearby system.<br>\n", trav(j).name);
  endif
fprintf(fid, "%d systems within %d parsecs of this world have a base influence of 10 or greater.<br>", sys_ten(j), syst_weeklyreport-2);
fprintf(fid, "\n</p><p>The systems with the most actual influence here are:<ul>\n");
for a=1:5
  nnam=sys(trav(j).influ.ndx(a,1),trav(j).influ.ndx(a,2),trav(j).influ.ndx(a,3)).name;
  nsec=sys(trav(j).influ.ndx(a,1),trav(j).influ.ndx(a,2),trav(j).influ.ndx(a,3)).subsectname;
  chdir(olddir);
  ndis=distance(trav(j), sys(trav(j).influ.ndx(a,1),trav(j).influ.ndx(a,2),trav(j).influ.ndx(a,3)));
  chdir(newdir);
  tref2=strcat('S',num2str(trav(j).influ.ndx(a,1)), ',', num2str(trav(j).influ.ndx(a,2)), nsec, ".html#", nnam);
  if (trav(j).influ.score(a)>0)
      fprintf(fid, "<li><a href=\"%s\">%s</a> in %s subsector is %d parsecs away and has an influence of %d.", tref2, strtrim(nnam), strtrim(nsec), ndis, trav(j).influ.score(a));
      if ((a==1)*(trav(j).govern==6)*(trav(j).influ.score(1)>trav(j).influ.confed))
          fprintf(fid, " %s controls their captive government.</li>\n", strtrim(nnam));
        elseif ((a==1)*(influj<trav(j).influ.score(a)))
          fprintf(fid, "  They are part of %s's pocket empire.</li>\n", strtrim(nnam));
        else
          fprintf(fid, "</li>\n");
        endif
    endif    
  endfor
fprintf(fid, "</ul></p>");
  
if (sy.influ.dominate(1)>0)
    fprintf(fid, "\n<p>The following worlds are part of %s's pocket empire.<ul>\n", sy.name);
  endif  
if (sy.influ.dominate>0)
    for a=1:length(sy.influ.dominate)
      nnam=sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)).name;
      nsec=sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)).subsectname;
      chdir(olddir);
      ndis=distance(trav(j), sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)));
      influj=influence(sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)));
      chdir(newdir);
      tref=strcat('S',num2str(trav(j).influ.ally(a,1)), ',', num2str(trav(j).influ.ally(a,2)), nsec, ".html#", nnam);
      tref2=strcat('S',num2str(trav(j).influ.ally(a,1)), ',', num2str(trav(j).influ.ally(a,2)), nsec, ".", syst_imagetype);
      fprintf(fid, "<li><a href=\"%s\">%s</a> in <a href=\"%s\" target=\"_blank\">%s subsector</a> is %d parsecs away and has an influence score of %d compared to %d for %s.\n", tref, nnam, tref2, nsec, ndis, influj, sy.influ.dominate(a), sy.name(:));
      if (sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)).influ.ally(1)>0)
          fprintf(fid, "<br>&nbsp&nbsp&nbsp %s has its own pocket empire of %d systems.</li>\n",nnam, length(sys(trav(j).influ.ally(a,1),trav(j).influ.ally(a,2),trav(j).influ.ally(a,3)).influ.dominate));
        else
          fprintf(fid, "</li>\n");
        endif  
      endfor
    fprintf(fid, "</ul></p>\n");  
  endif 
endif
  
   
fprintf(fid, "<p>%s has", trav(j).name);
b=0;
if (sy.naval==1)
    fprintf(fid, " a naval base,");
    b=1;
  endif  
if (sy.scout==1)
    fprintf(fid, " a scout base,");
    b=1;
  endif  
if (sy.consul==1)
    fprintf(fid, " a consulate,");
    b=1;
  endif  
if (sy.aid==1)
    fprintf(fid, " an explorer hostel,");
    b=1;
  endif  
if (b==0)
    fprintf(fid, " no bases");
    b=1;
  endif  
fprintf(fid, " and is under restriction status <span style=\"background-color: #%s\">%s</span>.<br>\n", restring(sy.restriction+1,:), strtrim(restrict((sy.restriction+1),:)));
if ((syst_confederation==1)*(cbases(j)>0))
    fprintf(fid,"The Confederation base(s) contact %d other systems weekly.<br>",cbases(j));
  endif
fprintf(fid,"It is within %d parsecs of %d systems with at least 1 million population.<br>", syst_weeklyreport-2, psystems(j));
fprintf(fid,"%d nearby systems have a technology level which permits them to jump here directly.<br>", jumpsys(j));

if (sum(sy.trade)>0)
    fprintf(fid, "Its trade characteristics are: ");
    for b=1:16
      if (sy.trade(b)>0)
          fprintf(fid, "%s,  ",strtrim(tradecodes(b,:)));
        endif  
      endfor
  endif
fprintf(fid, "</p>\n");

#primary star system printing
if ((sy.starlocation==1)+(sy.starlocation==3))
    let="AB";
  elseif (sy.starlocation==0)
    let="";
  else
    let="A";
  endif
if ((sy.planets-sy.companions)>0)
    temp=[trav(j).name "-" let];
    fprintf(fid, "<h3> Primary Solar System %s</h3>\n", temp);
  endif

if ((syst_traveltime==1)*((sy.planets-sy.companions)>1))
    fprintf(fid, "<p>Travel Time at 1g acceleration within the primary solar system(in hours).<br>\n");
    fprintf(fid, " For higher accelerations, divide the listed time by the square root of the ship's M-drive.</p>\n ");
    fprintf(fid, "<table border=\"1\" cellpadding=\"1\">\n <tr>");
    fprintf(fid,"<td></td>");
    for a=1:(sy.planets-sy.companions)
      fprintf(fid, "<th>%s</th>",char('a'+a-1));
      endfor
    fprintf(fid, "</tr>\n");
    for a=1:(sy.planets-sy.companions)
      fprintf(fid, "<td><strong>&nbsp%s&nbsp</strong></td>",char('a'+a-1));
      for b=1:a
        fprintf(fid, "<td>&nbsp%4s&nbsp</td>  ", strtrunc(num2str(sy.transit(a,b)),4));
        endfor
      fprintf(fid, "</tr>\n");  
      endfor
    fprintf(fid, "</table>\n");
  endif
if ((sy.starlocation==0)+(sy.starlocation==2))
    gravfelt=sy.grav(1);
  elseif ((sy.starlocation==1)+(sy.starlocation==3))
    gravfelt=sy.grav(1)+sy.grav(2);
  endif
for b=1:(sy.planets-sy.companions) 
  fprintf(fid, "<p><strong>%s%s</strong> ", [sy.name "-" let], char('a'+b-1));
  period= round(365*sqrt((sy.orbit(b)/150)^3/gravfelt));
  if (sy.planet(b)==0)
      fprintf(fid, "is an asteroid belt with many size 0 planetoids orbiting at %d million km.<br>\n", sy.orbit(b));
    elseif (sy.planet(b)==15)
      fprintf(fid, "is a gas giant with surface gravity of %dg, period of %d days, diameter of %d km and orbiting at %d million km.<br>\n",sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
    elseif (sy.planet(b)==14)
      fprintf(fid, "is an ice giant with surface gravity of %dg, period of %d days, diameter of %d km and orbiting at %d million km.<br>\n",sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
    else
      fprintf(fid, "is size %s, a surface gravity of %dg, a period of %d days, a diameter of %d km and orbiting at %d million km.<br>\n", dec2hex(sy.planet(b)), sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
      if ((sy.atm(b)>9)*(sy.hydro(b)>4)*(sy.planet(b)<14)*(sy.temp(b)==0))
          planstring="a hydrocarbon fluid ocean";
        else
          planstring="water";
        endif
      newhydro=max(min((sy.hydro(b)*10+(floor(rand*10)-5)),100),0)*(sy.temp(b)<8);
      fprintf(fid, "It is a %s world with %d%% covered by %s and %s atmosphere.<br>\n",strtrim(tempstring(sy.temp(b)+2,:)), newhydro, planstring(:), strtrim(atmostring(sy.atm(b)+1,:))); 
      if ((sy.bestp==b)+(sy.habitable(b)>0))
          fprintf(fid, "<span style=\"background-color: #%s\">It is %s habitable and has a UWP code of %s.</span><br>\n", habcolor(sy.habitable(b)+1,:), strtrim(habstring(sy.habitable(b)+1,:)), sy.uwp(b,:));
          if (sy.favor(b)>0)
              fprintf(fid, " The conditions on this planet are favored by %s.<br>\n", strtrim(favored(sy.favor(b),:))); 
            endif  
          if (sy.native>0)
              if ((sy.habit.planet(sy.native)==b)*(sy.habit.moon(sy.native)==0))
                  tref=strcat('S',num2str(sy.race.sector(1)), ',', num2str(sy.race.sector(2)), sy.race.subsectname, ".html#", strtrim(sy.race.name));
                  fprintf(fid, "<em> %s is the homeworld of the <a href=\"%s\">%ss,</a> a minor race.</em><br>\n", sy.name(:), tref, strtrim(sy.race.name));
                endif
            endif
        endif    
    endif
  if (sy.rings(b)>0)
      fprintf(fid, "There are %d rings encircling this giant planet.<br>\n", sy.rings(b));
    endif  
  if ((sy.bestp==b)*(sy.bestm==0))
      fprintf(fid, "<strong> %s%s is the most habitable world in the system.</strong><br>\n", [sy.name "-" let], char('a'+b-1));
    elseif ((sy.bestp==b)*(sy.bestm>0))
      fprintf(fid, "<strong> Moon %s%s%d is the most habitable world in the system.</strong><br>\n", [sy.name "-" let], char('a'+b-1), sy.bestm);
    endif
  if (sy.native>0)
      if ((sy.habit.planet(sy.native)==b)*(sy.habit.moon(sy.native)>0))
          tref=strcat('S',num2str(sy.race.sector(1)), ',', num2str(sy.race.sector(2)), sy.race.subsectname, ".html#", strtrim(sy.race.name));
          fprintf(fid, "<em> %s%s%d is the homeworld of the <a href=\"%s\">%ss,</a> a minor race.</em><br>\n", [sy.name "-" let], char('a'+b-1), sy.habit.moon(sy.native), tref, strtrim(sy.race.name));
        endif
    endif    
  
  if (sy.planet(b)>0)  
      fprintf(fid, "The planet has a total of %d large moons and %d moons of size 0 or less.</p>\n", sy.lmoons(b), sy.smoons(b));
    elseif(b==sy.bestp)
      fprintf(fid, "This belt is the most habitable region in the entire system with uwpcode %s.</p>\n", sy.uwp(b,:));
    else
      fprintf(fid, "\n");
    endif  

  if (sy.lmoons(b)>0)  
      fprintf(fid, "<table class=\"moons\">\n<tr>");
      fprintf(fid, "<th>&nbsp&nbsp&nbsp&nbsp</th><th>Moon </th><th> Size </th><th> Diam. (km) </th><th>orbit<br>1000's km </th><th> period<br>(days)</th><th> gravity</th><th> temperature</th>\n");
      fprintf(fid, "<th>Habitable </th><th>UWP</th><th>Favored </th></tr>\n");
      for c=1:sy.lmoons(b)
        period= ceil(27*((8/sy.planet(b))^3)*sqrt(((sy.moon.orbit(b,c)/385)^3)/sy.gravity(b)));
        fprintf(fid, "<tr style=\"background-color: #%s;\"><td></td><td>%s%d</td><td>%d</td><td>%d</td><td>%d</td><td>%d</td><td>%d g</td><td>%s</td>\n", habcolor(sy.moon.habitable(b,c)+1,:), char('a' -1 + b), c, sy.moon.size(b,c), sy.moon.radius(b,c), sy.moon.orbit(b,c), period, sy.moon.gravity(b,c), strtrim(tempstring((sy.moon.temp(b,c)+2),:)));
        if (sy.moon.habitable(b,c)>0)
            if (sy.moon.favor(b,c)>0)
                favstr= favored(sy.moon.favor(b,c),:);
              else
                favstr="";
              endif  
            fprintf(fid, "<td>%s</td><td> %s </td><td>%s</td></tr>\n", habstring(sy.moon.habitable(b,c)+1,:), sy.moon.uwp(b,c,:), favstr);
          endif
        endfor
        fprintf(fid, "</table>\n\n");  
    endif
  if (sy.native==0)
      if ((sy.bestp==b)*(sy.population>0)*(sy.tech<8))
          fprintf(fid, "<p><span style=\"background-color: #c0c0ff\">This habitable world is the only one occupied as the system does not have effective space travel.</span></p>\n");
        endif
    endif
  for c=1:sy.habnum
    if (sy.habit.planet(c)==b)
        at= round(sy.habit.axis.temp(c)+ ((0.8*sy.habit.axis.temp(c) +32)*(syst_temperature=="F")));
        ht= sy.habit.axis.temp(c)+ 0.5*sy.habit.axis.chg(c);
        ht= floor(ht+ ((0.8*ht +32)*(syst_temperature=="F")));
        mdw= sy.habit.axis.temp(c)- 1.5*(sy.habit.axis.sea(c)+2);
        mdw= ceil(mdw+ ((0.8*mdw +32)*(syst_temperature=="F")));
        mds= sy.habit.axis.temp(c)+ 1.5*(sy.habit.axis.sea(c)+2);
        mds= floor(mds+ ((0.8*mds +32)*(syst_temperature=="F")));
        lpw=sy.habit.axis.temp(c)- 0.5*sy.habit.axis.chg(c) - 3*(sy.habit.axis.sea(c)+2);
        lpw= ceil(lpw+ ((0.8*lpw +32)*(syst_temperature=="F")));
        lps= sy.habit.axis.temp(c)- 0.5*sy.habit.axis.chg(c) + 3*(sy.habit.axis.sea(c)+2);
        lps= ceil(lps+ ((0.8*lps +32)*(syst_temperature=="F")));
        if ((sy.habit.moon(c)==0)*(sy.geothermal(sy.habit.planet(c))==0))    # planet is habitable, not geothermal
            fprintf(fid, "%s%s has an average temperature of %d degrees %s.<br>\n", [sy.name "-" let], char('a'-1+b), at, syst_temperature);
            fprintf(fid, "&nbsp&nbspAvg temps range from %d to %d near the equator, %d to %d at 45 latitude, and %d to %d near the poles.<br>\n", ht-2, ht+2, mdw, mds, lpw, lps);
          elseif (sy.geothermal(sy.habit.planet(c))==0)
            fprintf(fid, "Moon %s%d has an average temperature of %d degrees celsius.<br>\n", char('a'-1+b), sy.habit.moon(c), sy.habit.axis.temp(c));
            fprintf(fid, "&nbsp&nbspAvg temps range from %d to %d near the equator, %d to %d at 45 latitude, and %d to %d near the poles.<br>\n", ht-2, ht+2, mdw, mds, lpw, lps);
          endif
      endif
    endfor
  if (sy.geothermal(b)>0)
      fprintf(fid, "This habitable world has volcanic vents which provide enough heat for life to exist.<br>\n");
    endif  
  if (b<sy.planets)
      fprintf(fid, "</ul><hr width=\"5%%\" align=\"left\">\n");
    endif  
  endfor

# companion system printing
if (sy.starlocation==2)
    let="B";
  elseif (sy.starlocation==3)
    let="C";
  else
    let="";
  endif
if (sy.companions>0)
    temp=[strtrim(trav(j).name) "-" let];
    fprintf(fid, "<p><h3> Companion Solar System %s</h3>\n", temp);
  endif

if ((syst_traveltime==1)*(sy.companions>1))
    fprintf(fid, "Travel Time at 1g acceleration within the primary solar system(in hours).<br>\n");
    fprintf(fid, " For higher accelerations, divide the listed time by the square root of the ship's M-drive.</p>\n ");
    fprintf(fid, "<table border=\"1\" cellpadding=\"1\">\n <tr>");
    fprintf(fid,"<td></td>");
    for a=1:sy.companions
      fprintf(fid, "<td><h4 align=\"center\">%s</h4></td>",char('a'+a-1));
      endfor
    fprintf(fid, "</tr>\n");
    for a=1:sy.companions
      fprintf(fid, "<td><strong>&nbsp%s&nbsp</strong></td>",char('a'+a-1));
      for b=1:a
        fprintf(fid, "<td align=\"center\">&nbsp%4s&nbsp</td>  ", strtrunc(num2str(sy.comptransit(a,b)),4));
        endfor
      fprintf(fid, "</tr>\n");  
      endfor
    fprintf(fid, "</table>\n");
  endif

if (sy.starlocation==1)
    gravfelt=sy.grav(2);
  elseif (sy.starlocation==3)
    gravfelt=sy.grav(3);
  endif
for b=(sy.planets-sy.companions)+1:sy.planets
  n= b-(sy.planets-sy.companions);
  fprintf(fid, "<p><strong>%s%s</strong> ", [sy.name "-" let], char('a'+n-1));
  period= round(365*sqrt((sy.orbit(b)/150)^3/gravfelt));
  if (sy.planet(b)==0)
      fprintf(fid, "is an asteroid belt with many size 0 planetoids orbiting at %d million km.<br>\n", sy.orbit(b));
    elseif (sy.planet(b)==15)
      fprintf(fid, "is a gas giant with surface gravity of %dg, period of %d days, diameter of %d km and orbiting at %d million km.<br>\n",sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
    elseif (sy.planet(b)==14)
      fprintf(fid, "is an ice giant with surface gravity of %dg, period of %d days, diameter of %d km and orbiting at %d million km.<br>\n",sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
    else
      fprintf(fid, "is size %s, a surface gravity of %dg, a period of %d days, a diameter of %d km and orbiting at %d million km.<br>\n", dec2hex(sy.planet(b)), sy.gravity(b), period, sy.radius(b), sy.orbit(b));
      if (sy.axis.rotation(b)>48)
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis approximately every %d days.<br>\n", sy.axis.tilt(b), round(sy.axis.rotation(b)/24));
        else
          fprintf(fid, "It has an axial tilt of %d degrees and rotates on its axis every %d hours.<br>\n", sy.axis.tilt(b), sy.axis.rotation(b));
        endif
      if ((sy.atm(b)>9)*(sy.hydro(b)>4)*(sy.planet(b)<14)*(sy.temp(b)==0))
          planstring="a hydrocarbon fluid ocean";
        else
          planstring="water";
        endif
      newhydro=max(min((sy.hydro(b)*10+(floor(rand*10)-5)),100),0)*(sy.temp(b)<8);
      fprintf(fid, "It is a %s world with %d%% covered by %s and %s atmosphere.<br>\n",strtrim(tempstring(sy.temp(b)+2,:)), newhydro, planstring(:), strtrim(atmostring(sy.atm(b)+1,:))); 
      if ((sy.bestp==b)+(sy.habitable(b)>0))
          fprintf(fid, "<span style=\"background-color: #%s\">It is %s habitable and has a UWP code of %s.</span><br>\n", habcolor(sy.habitable(b)+1,:), strtrim(habstring(sy.habitable(b)+1,:)), sy.uwp(b,:));
          if (sy.favor(b)>0)
              fprintf(fid, " The conditions on this planet are favored by %s.<br>\n", strtrim(favored(sy.favor(b),:))); 
            endif  
          if (sy.native>0)
              if ((sy.habit.planet(sy.native)==b)*(sy.habit.moon(sy.native)==0))
                  tref=strcat('S',num2str(sy.race.sector(1)), ',', num2str(sy.race.sector(2)), sy.race.subsectname, ".html#", strtrim(sy.race.name));
                  fprintf(fid, "<em> %s is the homeworld of the <a href=\"%s\">%ss,</a> a minor race.</em><br>\n", sy.name(:), tref, strtrim(sy.race.name));
                endif
            endif
        endif    
    endif
  if (sy.rings(b)>0)
      fprintf(fid, "There are %d rings encircling this giant planet.<br>\n", sy.rings(b));
    endif  
  if ((sy.bestp==b)*(sy.bestm==0))
      fprintf(fid, "<strong> %s%s is the most habitable world in the system.</strong><br>\n", [sy.name "-" let], char('a'+n-1));
    elseif ((sy.bestp==b)*(sy.bestm>0))
      fprintf(fid, "<strong> Moon %s%s%d is the most habitable world in the system.</strong><br>\n", [sy.name "-" let], char('a'+n-1), sy.bestm);
    endif
  if (sy.native>0)
      if ((sy.habit.planet(sy.native)==b)*(sy.habit.moon(sy.native)>0))
          tref=strcat('S',num2str(sy.race.sector(1)), ',', num2str(sy.race.sector(2)), sy.race.subsectname, ".html#", strtrim(sy.race.name));
          fprintf(fid, "<em> %s%s%d is the homeworld of the <a href=\"%s\">%ss,</a> a minor race.</em><br>\n", [sy.name "-" let], char('a'+n-1), sy.habit.moon(sy.native), tref, strtrim(sy.race.name));
        endif
    endif    
  
  if (sy.planet(b)>0)  
      fprintf(fid, "The planet has a total of %d large moons and %d moons of size 0 or less.</p>\n", sy.lmoons(b), sy.smoons(b));
    elseif(b==sy.bestp)
      fprintf(fid, "This belt is the most habitable region in the entire system with uwpcode %s.</p>\n", sy.uwp(b,:));
    else
      fprintf(fid, "\n");
    endif  

  if (sy.lmoons(b)>0)  
      fprintf(fid, "<table class=\"moons\">\n<tr>");
      fprintf(fid, "<th>&nbsp&nbsp&nbsp&nbsp</th><th>Moon </th><th> Size </th><th> Diam. (km) </th><th>orbit<br>1000's km </th><th> period<br>(days)</th><th> gravity</th><th> temperature</th>\n");
      fprintf(fid, "<th>Habitable </th><th>UWP</th><th>Favored </th></tr>\n");
      for c=1:sy.lmoons(b)
        period= ceil(27*((8/sy.planet(b))^3)*sqrt(((sy.moon.orbit(b,c)/385)^3)/sy.gravity(b)));
        fprintf(fid, "<tr style=\"background-color: #%s;\"><td></td><td>%s%d</td><td>%d</td><td>%d</td><td>%d</td><td>%d</td><td>%d g</td><td>%s</td>\n", habcolor(sy.moon.habitable(b,c)+1,:), char('a'+ n-1), c, sy.moon.size(b,c), sy.moon.radius(b,c), sy.moon.orbit(b,c), period, sy.moon.gravity(b,c), strtrim(tempstring((sy.moon.temp(b,c)+2),:)));
        if (sy.moon.habitable(b,c)>0)
            if (sy.moon.favor(b,c)>0)
                favstr= favored(sy.moon.favor(b,c),:);
              else
                favstr="";
              endif  
            fprintf(fid, "<td>%s</td><td> %s </td><td>%s</td></tr>\n", habstring(sy.moon.habitable(b,c)+1,:), sy.moon.uwp(b,c,:), favstr);
          endif
        endfor
        fprintf(fid, "</table>\n\n");  
    endif
  if (sy.native==0)
      if ((sy.bestp==b)*(sy.population>0)*(sy.tech<8))
          fprintf(fid, "<p><span style=\"background-color: #9bcfb8\">This habitable world is the only one occupied as the system does not have effective space travel.</span></p>\n");
        endif
    endif
  for c=1:sy.habnum
    if (sy.habit.planet(c)==b)
        ht= floor(sy.habit.axis.temp(c)+ 0.5*sy.habit.axis.chg(c));
        mdw= ceil(sy.habit.axis.temp(c)- 1.5*(sy.habit.axis.sea(c)+2));
        mds= floor(sy.habit.axis.temp(c)+ 1.5*(sy.habit.axis.sea(c)+2));
        lpw= ceil(sy.habit.axis.temp(c)- 0.5*sy.habit.axis.chg(c) - 3*(sy.habit.axis.sea(c)+2));
        lps= ceil(sy.habit.axis.temp(c)- 0.5*sy.habit.axis.chg(c) + 3*(sy.habit.axis.sea(c)+2));
        if ((sy.habit.moon(c)==0)*(sy.geothermal(sy.habit.planet(c))==0))    # planet is habitable, not geothermal
            fprintf(fid, "%s%s has an average temperature of %d degrees celsius.<br>\n", [sy.name "-" let], char('a'-1+n), sy.habit.axis.temp(c));
            fprintf(fid, "&nbsp&nbspSeasonal avg temps range from %d to %d near the equator, %d to %d at 45 latitude, and %d to %d near the poles.<br>\n", ht-2, ht+2, mdw, mds, lpw, lps);
          elseif (sy.geothermal(sy.habit.planet(c))==0)
            fprintf(fid, "Moon %s%d has an average temperature of %d degrees celsius.<br>\n", char('a'-1+n), sy.habit.moon(c), sy.habit.axis.temp(c));
            fprintf(fid, "&nbsp&nbspSeasonal avg temps range from %d to %d near the equator, %d to %d at 45 latitude, and %d to %d near the poles.<br>\n", ht-2, ht+2, mdw, mds, lpw, lps);
          endif
      endif
    endfor
  if (sy.geothermal(b)>0)
      fprintf(fid, "This habitable world has volcanic vents which provide enough heat for life to exist.<br>\n");
    endif  
  if (b<sy.planets)
      fprintf(fid, "</ul><hr width=\"5%%\" align=\"left\">\n");
    endif  
  endfor

if (sy.planets>0)
    fprintf(fid, "<p><a href=\"#list\">Return to list.</a></p>");
  endif 
fprintf(fid, "</ul><hr width=\"40%%\" align=\"left\">\n"); 

endfor

fprintf(fid, "</body>");

fclose(fid);
chdir(olddir);
endfunction

for x=1:length(sys(:,1,1))
  for y=1:length(sys(1,:,1))
    cnt=1;  
    for i=1:length(sys(x,y,:))
      if (sys(x,y,i).starnum>0)
          cnt=cnt+1;
        endif  
      endfor 
    trav=sys(x,y,1:cnt-1);   # make trav the variable name for subsector systems
    printsector(sys, trav, newrace, olddir, newdir,tr,distance_array);
    endfor
  endfor


#    printsector(sys, trav, newrace, olddir, newdir);

