# create an influence matrix for a subsector + neighbors

function related=newinfluence(trav)   # trav= linear matrix of systems 

gov(1,:)= [ 3  0  0 -3  0  0  3 -3  0  0 -3 -3 -3 -3];
gov(2,:)= [ 0  3  0  0  0  0  3 -3  0  0  0  0  0 -3];
gov(3,:)= [ 0  0  3 -3  3  0  3 -3  0  0 -3 -3 -3 -3];
gov(4,:)= [-3  0 -3  3 -3  0  3 -3 -3 -3  3  3  3 -3];
gov(5,:)= [ 0  0  3 -3  3  0  3 -3  0  0 -3 -3 -3 -3];
gov(6,:)= [ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(7,:)= [-5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5];
gov(8,:)= [-5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5 -5];
gov(9,:)= [ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(10,:)=[ 0  0  0 -3  0  3  3 -3  3  3 -3 -3 -3 -3];
gov(11,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(12,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(13,:)=[-3 -3 -3  3 -3 -3  3 -3 -3 -3  3  3  3 -3];
gov(14,:)=[-3 -3 -3 -3 -3 -3  3 -3 -3 -3 -3 -3 -3 -3];

full_variables

# make an influence matrix for how each planet influences each other
for b=1:length(trav)
  for c=1:length(trav)                 
    infc=influence(trav(c));
    d= distance(trav(b),trav(c));
    related(b,c)=infc-2*d +(2-abs(trav(b).law-trav(c).law))+gov(trav(c).govern+1,trav(b).govern+1);
    if (d==0)
        related(b,c)=infc;
      endif  
    related(b,c)=max(0, related(b,c));
    related(b,c)=(infc>0)* related(b,c);
    endfor
  endfor

endfunction
  
