# function adding population centers to systems

function popdis=popcenters(trav)
popdis=[0 0 0 0 0 0 0 0 0];     # variable for the major population centers

#trav.population= log number of sophonts
#trav.pop= x.y portion of the population

if (trav.population==1)             # 10's of people
    popdis(1)=1;                      # everyone lives in 1 outpost
  elseif (trav.population==2)       # 100's of people
    popdis(2)=1;                      # one hamlet
    if (trav.pop<2)
        popdis(1)=floor(rand()*3);    # 0-2 outposts
      endif
  elseif (trav.population==3)       # 1000's of people
    if (trav.pop<5+floor(rand()*20)/10)
        popdis(3)=1;
      else
        popdis(3)=2;                  # 1-2 villages  
      endif
    popdis(2)= floor(rand()*floor(trav.population));  # 0-8 hamlets
  elseif ((trav.population<8)*(trav.population>3))       # 10,000 to 10 millions people
    popdis(trav.population)= floor(trav.pop/(3+(rand()*2.1))); # 0- ~3 max size units
    popdis(trav.population-1)= floor((trav.pop*10- 40*popdis(trav.population))/(3+(rand()*3.5)));   # 0- some next unit down
  elseif (trav.population==8)       # 100's millions of people
    popdis(7)= 1+ floor(trav.pop*10/(8+(rand()*3.1))); # at least 1 metropolis
    popdis(6)= floor((trav.pop*100- 40*popdis(7))/(6+(rand()*2.5)));   # 0- some large cities
  elseif (trav.population==9)       # billions of people
    popdis(7)= floor(trav.pop*100/(8+(rand()*3))); # at least 1 metropolis
    popdis(6)= floor((trav.pop*1000- 70*popdis(7))/(8+(rand()*2.5)));   # 0- some large cities
  elseif (trav.population==10)       # 10's billions of people
    popdis(8)= floor(trav.pop*100/(8+(rand()*3))); # many arcologies
    popdis(7)= floor((trav.pop*1000- 70*popdis(8))/(8+(rand()*2.5)));   # lots metropolis
  endif

endfunction
  

  